<?php
require_once('PathTool.php');	

class DAttr
{
	var $_htmlName;
	var $_key;
	var $_type;
	var $_minVal;
	var $_maxVal;
	var $_inputType;
	var $_inputAttr;
	var $_label;
	var $_allowNull;
	var $_glue;
	var $_href;
	var $_defaultVal;
	var $_multiInd;
	var $_hideNull;
	var $_version;

// public:
	function DAttr($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
	{
		$this->_htmlName = $key;
		$this->_key = $key;
		$this->_type = $type;
		$this->_minVal = $min;
		$this->_maxVal = $max;
		$this->_inputType = $inputType;
		$this->_inputAttr = $inputAttr;
		$this->_label = $label;
		$this->_allowNull = $allowNull;
		$this->_multiInd = 0;
		$this->_defaultVal = NULL;
		$this->_hideNull = false;
		$this->_version = 0; 
	}

	function extract(&$from, &$to, &$err)
	{
		$err[$this->_key] = NULL;
		if ( $this->_multiInd == 2 )
		{
			return $this->extract2( $from, $to, $err );
		}
		if ( $this->_type === 'checkboxOr' )
			$to[$this->_key] = $this->extractCheckBoxOr( $from );
		else
			$to[$this->_key] = trim($from[$this->_key]);

		if ( $this->_multiInd == 1 )
			return $this->isValid1($to[$this->_key], $err[$this->_key]);
		else
			return $this->isValid0($to[$this->_key], $err[$this->_key]);
	}

	function extractCheckBoxOr(&$from)
	{
		if ( isset($from[$this->_key]) )
			return $from[$this->_key];

		$value = 0;
		$novalue = 1;
		foreach( $this->_maxVal as $val => $disp )
		{
			$name = $this->_key . $val;
			if ( isset( $from[$name] ) )
			{
				$novalue = 0;
				$value = $value | $val;
			}
		}
		if ( $novalue )
			return '';
		else
			return $value;
	}

    function extract2(&$from, &$to, &$err)
    {
		$valid = 1;
		if ( isset( $from[$this->_htmlName] ) )
		{ // from post
			$to[$this->_key] = preg_split("/\n+/", $from[$this->_htmlName], -1, PREG_SPLIT_NO_EMPTY);
		}
		else
		{
			$to[$this->_key] = $from[$this->_key];
		}

		if ( is_array($to[$this->_key]) )
		{ 
			foreach( $to[$this->_key] as $i => $value )
			{
				$to[$this->_key][$i] = trim($value);
				$err[$this->_key][$i] = NULL;
				$res = $this->isValid0($to[$this->_key][$i], $err[$this->_key][$i]);
				if ( $res == -1 )
					$valid = -1;
				elseif ( $res == 0 && $valid == 1 )
					$valid = 0;
			}
		}
		else
		{
			$valid = $this->isValid0($to[$this->_key], $err[$this->_key]);
		}

		return $valid;
	}

	function splitMultiple(&$value)
	{
		$vals = preg_split("/[,;]+/", $value, -1, PREG_SPLIT_NO_EMPTY);
		$value = implode(', ', $vals);
		return $vals;
	}

	function isValid0(&$value, &$err)
	{
		if ( $value == NULL )
		{
			if ( $this->_allowNull )
				return 1;
			$err = 'value must be set';
			return -1;
		}
		return $this->check( $value, $err );
	}

	function isValid1(&$value, &$err)
	{
		$vals = $this->splitMultiple( $value );
		if ( $value === NULL || $value === '' )
		{
			if ( $this->_allowNull )
				return 1;
			$err = 'value must be set';
			return -1;
		}
		$e = '';
		$isValid = 1;
		foreach( $vals as $val )
		{
			$err1 = '';
			$isValid1 = $this->check($val, $err1);
			$e .= $err1;
			if ( $isValid1 == -1 )
				$isValid = -1;
			elseif ( $isValid == 0 && $isValid == 1 )
				$isValid = 0;
		}
		$err = $e;
		return $isValid;
	}

	function check(&$val, &$err)
	{
		if ( preg_match("/[<>\'\"\&]/", $val ) )
		{
			$err = 'invalid character found in ' . htmlspecialchars($val) ;
			return -1;
		}
		switch( $this->_type )
		{
		case 'uint': return $this->chk_uint($val, $err);
		case 'name': return $this->chk_name($val, $err);
		case 'sel':  return $this->chk_sel($val, $err);
		case 'bool': return $this->chk_bool($val, $err);
			/*case 'path': 
		case 'filep': */
		case 'file': return $this->chk_file($val, $err);
		case 'uri': return $this->chk_uri($val, $err);
		case 'expuri': return $this->chk_expuri($val, $err);
		case 'url': return $this->chk_url($val, $err);
		case 'domain': return $this->chk_domain($val, $err);
		case 'email': return $this->chk_email($val, $err);
		case 'dir': return $this->chk_dir($val, $err);
		case 'subnet': return $this->chk_subnet($val, $err);
		case 'addr': return $this->chk_addr($val, $err);
		case 'parse': return $this->chk_parse($val, $err);
		}		
		return 1;
	}

	function blockedVersion()
	{
		if ( $this->_version == 0 )
			return false;

		$a = $_SERVER['LSWS_EDITION'];
		if ( $this->_version == 1 && $a == 'Pro' )
			return false;
		else
			return true;
	}

	function hideHtml(&$data, $seq)
	{
		if ( $this->_hideNull )
		{
			if ( $seq === NULL )
				$value = &$data[$this->_key];
			else
				$value = &$data[$this->_key][$seq];
			if ( !isset($value) || $value === NULL || $value === '' )
				return true;
		}
		return false;
		
	}

	function toHtml(&$data, &$error, $seq)
	{
		$output = '';
		if ( $seq === NULL )
		{
			$value = &$data[$this->_key];
			$err = &$error[$this->_key];
		}
		else
		{
			$value = &$data[$this->_key][$seq];
			$err = &$error[$this->_key][$seq];
		}
		if ( is_array( $value ) )
		{
			for ( $i = 0 ; $i < count($value) ; ++$i )
			{
				$output .= $this->toHtmlContent( $value[$i], $err[$i] );
				$output .= '<br>';
			}
		}
		else
			$output .= $this->toHtmlContent( $value, $err );
		return $output;
	}

	function toHtmlContent( &$value, &$err )
	{	
		//if ( $this->_type == 'file' || $this->_type == 'filep' || $this->_type == 'path' )
		//$this->chk_file($value, $err);

		$output = '';
		if ( $err )
			$output .= '<span class="error">*' . $this->check_split($err, 70) . '</span><br>';

		if ( $value === NULL || $value === '' )
		{
			$output .= '<span class="novalue">N/A</span>';
			return $output;
		}

		if ( $this->_href )
			$output .= '<a href=' . $this->_href . '>';

		if ( $this->_type === 'bool' )
		{
			if ( $value === '1' )
				$output .= 'Yes';
			elseif ( $value === '0' )
				$output .= 'No';
			else
				$output .= '<span class="novalue">N/A</span>';
		}
		elseif ( $this->_type === 'sel' )
		{
			if ( isset( $this->_maxVal[$value] ) )
				$output .= $this->_maxVal[$value];
			else
				$output .= $value;
		}
		elseif ( $this->_type === 'checkboxOr' )
		{
			foreach( $this->_maxVal as $val=>$name )
			{
				if ( ($value & $val) || ($value == $val) )
					$gif = 'checked.gif';
				else
					$gif = 'unchecked.gif';
				$output .= '<img src="/images/graphics/'.$gif.'" width="12" height="12"> ';
				$output .= $name . '&nbsp;&nbsp;&nbsp;';
			}
		}
		elseif ( $this->_inputType === 'text' )
			$output .= $this->check_split($value, 60);
		else
			$output .= $value;

		if ( $this->_href )
			$output .= '</a>';

		return $output;
	}

	function getNote()
	{
		if ( $this->_type == 'uint' )
		{
			if ( $this->_maxVal )
				return 'number valid range: '. $this->_minVal . ' - ' . $this->_maxVal;
			elseif ( $this->_minVal !== NULL )
				return 'number &gt;= '. $this->_minVal ;
		}		
		return null;
	}

	function check_split($value, $width)
	{
		$val = explode(' ', $value);
		$changed = false;
		for( $i = 0 ; $i < count($val) ; ++$i )
		{
			if ( strlen($val[$i]) > $width )
			{
				$val[$i] = chunk_split($val[$i], $width, ' ');
				$changed = true;
			}
		}
		if ( $changed )
			return implode(' ', $val);
		else
			return $value;
	}

	function toHtmlInput($class, $seq, &$data, &$error, $isDisable)
	{
		$value = $data[$this->_key];
		$err = $error[$this->_key];
		$name = $this->_htmlName;
		if ( $seq != NULL )
		{
			$name = $this->_htmlName . $seq;
		}
		if ( is_array( $value ) && $this->_inputType != 'checkbox' )
		{
			$err1 = '';
			if ( is_array($err) )
			{
				foreach( $err as $e )
				{
					if ( $e )
						$err1 .= $this->check_split($e, 70).'<br>';
				}
				$err = $err1 ;
			}
			else
				$err = $this->check_split($err, 70);

			if ( $this->_multiInd == 1 )
				$glue = ', ';
			else
				$glue = "\n";
			$value = implode( $glue, $value );
		}
		else
			$err = $this->check_split($err, 70);

		$input = '';
		$note = $this->getNote();
		if ( $note )
			$input .= '<span class="edit-note">'.$note .'</span><br>';
		if ( $err )
			$input .= '<span class="error">*' . $err . '</span><br>';

		if ( $isDisable )
			$att = $this->_inputAttr . ' disabled';
		else
			$att = $this->_inputAttr;

		if ( $this->_inputType === 'text' )
		{
			$input .= '<input class="' . $class . '" type="text" name="'.$name.'" '.$att.' value="' .$value. '">';
			return $input;
		}
		if ( $this->_inputType === 'textarea')
		{
			$input .= '<textarea class="' . $class . '" name="'.$name.'" '.$att.'>'.$value. '</textarea>';
			return $input;
			
		}
		if ( $this->_inputType === 'radio' && $this->_type === 'bool')
		{
			$input .= '<input type="radio" name="'.$name.'" '.$att.' value="1" ';
			if ( $value == '1' )
				$input .= 'checked';
			$input .= '>Yes &nbsp;&nbsp;&nbsp;&nbsp;';
			$input .= '<input type="radio" name="'.$name.'" '.$att.' value="0" ';
			if ( $value == '0' )
				$input .= 'checked';
			$input .= '>No';
			if ( $this->_allowNull )
			{
				$input .= '&nbsp;&nbsp;&nbsp;&nbsp;<input type="radio" name="'.$name.'" '.$att.' value="" ';
				if ( $value != '0' && $value != '1' )
					$input .= 'checked';
				$input .= '>N/A';
			}
			return $input;
		}

		if ( $this->_inputType === 'checkbox' )
		{
			$input .= '<input type="checkbox" name="'.$name.'" '.$att.' value="'.$value['val'].'"';
			if ( $value['chk'] )
				$input .= ' checked';
			$input .= '>' . $value['val'];
			return $input;
		}

		if ( $this->_inputType === 'checkboxgroup' )
		{
			foreach( $this->_maxVal as $val=>$disp )
			{
				$input .= '<input type="checkbox" name="'.$name.$val.'" value="'.$val.'"';
				if ( ($value & $val) || ($value === $val) )
					$input .= ' checked';
				$input .= '> ' . $disp . '&nbsp;&nbsp;&nbsp;';
			}
			return $input;
		}

		if ( $this->_inputType === 'select' )
		{
			$input .= '<select name="'.$name.'" '.$att.'>';
			$input .= ($this->genOptions($this->_maxVal, $value));
			$input .= '</select>';
			return $input;
		}


	}

//private:
	function &genOptions(&$options, $selValue)
	{
		$output = '';
		if ( $options )
		{
			foreach ( $options as $key => $value )
			{
				$output .= '<option value="' . $key .'"';
				if ( $key == $selValue )
					$output .= ' selected';
				$output .= ">$value</option>\n";
			}
		}
		return $output;
	}

	function chk_sel(&$value, &$err)
	{
		if ( isset( $this->_maxVal ) )
		{
			$keys = array_keys($this->_maxVal);
			if ( !in_array( $value, $keys ) )
			{
				$err = 'invalid value';
				return -1;
			}
		}
		return 1;
	}

	function chk_name(&$value, &$err)
	{
		$value = preg_replace("/\s+/", ' ', $value);
		if ( ! preg_match( "/[[:alnum:]-_:*@]+/", $value ) )
		{
			$err = 'invalid characters in name, only allow alphanumerics';
			return -1;
		}
		if ( strlen($value) > 30 )
		{
			$err = 'name can not be longer than 30 characters';
			return -1;
		}
		return 1;
	}

	function allow_create($absname)
	{
		if ( strpos($this->_maxVal, 'c') === false )
			return false;
		if ( $this->_minVal >= 2 
			 && ( strpos($absname, $_SERVER['HTTPD_SERVER_ROOT'])  === 0 ))
			return true;
		
		if ( $this->_minVal >= 3 
			 && ( strpos($absname, $_SESSION['VH_ROOT']) === 0 ) )
			return true;

		if ( $this->_minVal == 4
			 && ( strpos($absname, $_SESSION['DOC_ROOT']) === 0 ) )
			return true;

		return false;
	}

	function test_file(&$absname, &$err)
	{
		$absname = PathTool::clean($absname);
		if ( isset( $_SERVER['LSWS_CHROOT'] ) )
		{
			$root = $_SERVER['LSWS_CHROOT'];
			$len = strlen($root);
			if ( strncmp( $absname, $root, $len ) == 0 )
				$absname = substr($absname, $len);
		}
		if ( PathTool::isDenied($absname) )
		{
			$err = 'Cannot use this directory for security reasons.';
			return -1; 
		}

		$type = ($this->_type == 'filep')?'path':$this->_type;
		if ( ($type != 'file' && !is_dir($absname))
			 || ($type == 'file' && !is_file($absname)) )
		{
			$err = $type .' '. $absname . ' does not exist.';
			if ( $this->allow_create($absname) )
			{
				$err .= ' <a href="javascript:createFile(\''. $this->_htmlName . '\')">CLICK TO CREATE</a>';

			}
			else
			{
				$err .= ' Please create manually.';
			}

			return -1;
		}
		if ( (strpos($this->_maxVal, 'r') !== false) && !is_readable($absname) )
		{
			$err = $type . ' '.$absname . ' is not readable';
			return -1;
		}
		if ( (strpos($this->_maxVal, 'w') !== false) && !is_writable($absname) )
		{
			$err = $type . ' '.$absname . ' is not writable';
			return -1;
		}
		if ( (strpos($this->_maxVal, 'x') !== false) && !is_executable($absname) )
		{
			$err = $type . ' '.$absname . ' is not executable';
			return -1;
		}
		return 1;
	}

	function chk_file(&$value, &$err)
	{
		if ($value == NULL )
			return 1;
		clearstatcache();
		$err = NULL;

		if ( $this->_type == 'filep' )
			$path = substr($value, 0, strrpos($value,'/'));
		else
			$path = $value;

		$res = $this->chk_file1($path, $err);
		if ( $res == -1 
			 && $_POST['file_create'] == $this->_htmlName 
			 && $this->allow_create($path) )
		{
			if ( PathTool::createFile($path, $err) )
				$err = "$path was created successfully.";
			$res = 0; // make it always point to curr page
		}
		return $res;
	}

	function chk_file1(&$path, &$err)
	{
		$s = $path{0};

		if ( $this->_minVal == 4 )
		{
			if ( $s == '/' )
			{
			}
			elseif ( strncasecmp('$SERVER_ROOT', $path, 12) == 0 )
			{
				$path = $_SERVER['HTTPD_SERVER_ROOT'] . substr($path, 13);
			}
			elseif ( strncasecmp('$VH_ROOT', $path, 8) == 0 )
			{
				$path = $_SESSION['VH_ROOT'] . substr($path, 9);
			}
			elseif ( strncasecmp('$DOC_ROOT', $path, 9) == 0 )
			{
				$path = $_SESSION['DOC_ROOT'] . substr($path, 10);
			}
			else
			{
				$path = $_SESSION['DOC_ROOT'] . $path;
			}
			if ( file_exists($path) )
				return 1;
			else
			{
				$err = 'file ' . $path . ' does not exist';
				return -1;
			}

		}

		if ( $s == '/' )
			return $this->test_file( $path, $err );

		if ( $this->_minVal == 1 )
		{
			$err = 'only accept absolute path';
			return -1;
		}
		elseif ( $this->_minVal == 2 )
		{
			if ( strncasecmp('$SERVER_ROOT', $path, 12) != 0 )
			{
				$err = 'only accept absolute path or path relative to $SERVER_ROOT';
				return -1;
			}
			else
				$path = $_SERVER['HTTPD_SERVER_ROOT'] . substr($path, 13);
		}
		elseif ( $this->_minVal == 3 )
		{
			if ( strncasecmp('$SERVER_ROOT', $path, 12) == 0 )
			{
				$path = $_SERVER['HTTPD_SERVER_ROOT'] . substr($path, 13);
			}
			elseif ( strncasecmp('$VH_ROOT', $path, 8) == 0 )
			{
				$path = $_SESSION['VH_ROOT'] . substr($path, 9);
			}
			else
			{
				$err = 'only accept absolute path or path relative to $SERVER_ROOT or $VH_ROOT';
				return -1;
			}
		}
		return $this->test_file( $path, $err );
	}

	function chk_uri(&$value, &$err)
	{
		if ( $value{0} != '/' )
		{
			$err = 'URI must start with "/"';
			return -1;
		}
		return 1;
	}

	function chk_expuri(&$value, &$err)
	{
		if ( $value{0} == '/' || strncmp( $value, 'exp:', 4 ) == 0 )
			return 1;
		else
		{
			$err = 'URI either start with "/" or "exp:"';
			return -1;
		}
	}

	function chk_url(&$value, &$err)
	{
		if (( $value{0} != '/' )
			&&( strncmp( $value, 'http://', 7 ) != 0 )
			&&( strncmp( $value, 'https://', 8 ) != 0 ))
		{
			$err = 'URL must start with "/" or "http(s)://"';
			return -1;
		}
		return 1;
	}

	function chk_domain(&$value, &$err)
	{
		return 1;
	}

	function chk_email(&$value, &$err)
	{
		if ( preg_match("/^[[:alnum:]._-]+@.+/", $value ) )
			return 1;
		else
		{
			$err = 'invalid email format: '.$value;
			return -1;
		}
	}

	function chk_dir(&$value, &$err)
	{
		$dir = $value;
		if ( substr($dir,-1) == '*' )
			return $this->chk_file(substr($value,0,-1), $err);
		else
			return $this->chk_file($value, $err);		
	}

	function chk_subnet(&$value, &$err)
	{
		return 1;
	}

	function chk_addr(&$value, &$err)
	{
		if ( preg_match("/^[[:alnum:]._-]+:(\d)+$/", $value) )
			return 1;
		elseif ( preg_match("/^UDS:\/\/.+/i", $value) )
			return 1;
		else
		{
			$err = 'invalid address, syntax is "IPV4_address:port" or UDS://path';
			return -1;
		}
	}

	function chk_bool(&$value, &$err)
	{
		if ( $value === '1' || $value === '0' )
			return 1;
		$err = 'invalid value';
		return -1;
	}

	function chk_parse(&$value, &$err)
	{
		if ( preg_match($this->_minVal, $value) )
			return 1;
		else
		{
			$err = 'invalid format - ' . $value . ', syntax is '.$this->_maxVal;
			return -1;
		}
	}

	function getKNum($tag)
	{
		if ( $tag === 'K' )
			return 1024;
		elseif ( $tag === 'M' )
			return 1048576;
		elseif ( $tag === 'G' )
			return 1073741824;
		else
			return 1;
	}

	function chk_uint(&$value, &$err)
	{
		if ( preg_match("/^(\d+)([KkMmGg]?)$/", $value, $m) )
		{
			if ( $this->_minVal || $this->_maxVal)
			{
				$min = $this->_minVal;
				$max = $this->_maxVal;
				if ( $min )
				{
					$t = $this->getKNum( substr($min, -1) );
					if ( $t != 1 )
						$min = intval(substr($min, 0, -1)) * $t;
				}
				if ( $max )
				{
					$t = $this->getKNum( substr($max, -1) );
					if ( $t != 1 )
						$max = intval(substr($max,0,-1)) * $t; 
				}
				$t = 1;
				if ( $m[2] )
				{
					$m[2] = ucfirst($m[2]);
					$t = $this->getKNum($m[2]);
				}
				$val = intval($m[1]) * $t;
				if ( ($this->_minVal && $val < $min)
					 || ($this->_maxVal && $val > $max) ) 
				{ 
					$err = 'number out of range';
					return -1;
				}
			}
			return 1;
		}
		else
		{
			$err = 'invalid number format';
			return -1;
		}
	}

	function dbg_out($tag, &$obj)
	{
		echo "<!-- $tag --\n";
		var_dump($obj);
		echo "-->\n";
	}
	function dbg_tag($tag)
	{
		echo "<!-- $tag -->\n";
	}


}
?>