<?php

require_once 'DAttr.php';

class DTbl
{
	var $_id;
	var $_titleCenter;
	var $_titleLeft;
	var $_cols;
	var $_showHeader;
	var $_titleActionLink;
	var $_dattrs;

	var $_width = 575;
	var $_labelWid;
	var $_align;
	var $_isMulti;

	function DTbl($id, $titleCenter, $cols, $showHeader, $titleActionLink)
    {
		$this->_id = $id;
		$this->_titleCenter = $titleCenter;
		$this->_cols = $cols;
		$this->_showHeader = $showHeader;
		$this->_titleActionLink = $titleActionLink;
	}

	function setDAttr(&$attrs)
	{
		$this->_dattrs = &$attrs;
	}

	function &getDAttr()
	{
		return $this->_dattrs;
	}

	function setTitle($type, $title)
	{
		if ( strlen($title) > 25 )
			$title = substr($title, 0, 25) . '...';
		if ( $type === 'L' )
			$this->_titleLeft = $title;
		elseif ( $type === 'C' )
			$this->_titleCenter = $title;
	}

	function extractValue(&$from, &$to, &$err)
	{
		$goFlag = 1 ;
		$keys = array_keys($this->_dattrs);

		foreach( $keys as $i )
		{
			$attr = &$this->_dattrs[$i];
			if ( $attr->_inputType && !$attr->blockedVersion())
			{
				$go = $attr->extract($from, $to, $err);
				if ( $goFlag == 1 && $go == 0 )
					$goFlag = 0;
				elseif ( $go == -1 )
					$goFlag = -1;
			}
		}
		return $goFlag;
	}

	function printHeaderLine($isInput)
	{
		$buf = '';
		$buf .= '<table align="center" width="'.$this->_width.'" class="gt" border="0" cellpadding="5" cellspacing="1">' . "\n";
		$buf .= '<tr class="gt-title"><td colspan=' . $this->_cols . '>';// . $this->_titleCenter."</td></tr>\n";
		if ( $this->_titleLeft || (!$isInput && $this->_titleActionLink) )
		{
			$buf .= '<table width="100%" border="0" cellpadding="0" cellspacing="0"><tr>'."\n";
			$tdwid =  ($this->_titleCenter) ? 'width="150"' : '';
			if ( $this->_titleLeft )
				$buf .= '<td nowrap ' . $tdwid . 'class="gt-title-l">' . $this->_titleLeft . '</td>';
			else
				$buf .= '<td width="150">&nbsp;</td>';

			if ( $this->_titleCenter )
				$buf .= '<td nowrap class="gt-title">'. $this->_titleCenter.'</td>';

			if ( !$isInput && $this->_titleActionLink )
				$buf .= '<td width="150" nowrap class="edit-link">'.$this->_titleActionLink.'</td>';
			$buf .= '</tr></table>'."\n";
		}
		else
			$buf .= $this->_titleCenter;
		$buf .= '</td></tr>'."\n";

		if ( $this->_showHeader && $this->_isMulti )
		{
			$buf .= '<tr class="gt-header">';
			$keys = array_keys($this->_dattrs);
			foreach( $keys as $i )
			{
				$attr = &$this->_dattrs[$i];
				if ( !$isInput || $attr->_inputType )
				{
					$buf .= '<td';
					if ( isset($this->_labelWid[$i]) )
						$buf .= ' width="' . $this->_labelWid[$i] . '"';
					$buf .= '>' . $attr->_label . '</td>';
				}
			}
			$buf .= '</tr>'."\n";
		}
		echo $buf;
	}

	function printHtmlLine(&$data, &$err, $index, $seq)
	{
		$attr = &$this->_dattrs[$index];
		if ( $attr->blockedVersion() || $attr->hideHtml($data, $seq) )
			return;

		$buf = '<tr>';
		if ( $this->_showHeader && !$this->_isMulti)
			$buf .= '<td class="gt-header">'.$attr->_label.'</td></tr><tr>';
		elseif ( $attr->_label )
		{
			$buf .= '<td nowrap';
			if ( isset( $this->_labelWid ) )
				$buf .= ' width="'.$this->_labelWid . '"';
			$buf .= ' class="gt-label">' . $attr->_label .'</td>';
		}
		$buf .= '<td width="80%" class="gt-content">';
		$buf .= ($attr->toHtml($data, $err, $seq));
		$buf .= "</td></tr>\n";
		echo $buf;
	}

	function toHtml(&$data, &$err, $seq)
	{
		$this->printHeaderLine(false);

		$keys = array_keys($this->_dattrs);
		foreach( $keys as $i )
		{
			$this->printHtmlLine($data, $err, $i, $seq);
		}
		echo "</table>\n";

	}

	function printHtmlInputLine(&$data, &$err, $index, $seq, $isDisable)
	{
		$attr = &$this->_dattrs[$index];
		if ( $attr->blockedVersion() )
			return;
		$buf = '<tr>';
		if ( $this->_showHeader && !$this->_isMulti )
			$buf .= '<td class="gt-header">'.$attr->_label.'</td></tr><tr><td class="gt-content-c">';
		elseif ( $attr->_label )
			$buf .= '<td class="gt-label">' . $attr->_label .'</td><td class="gt-content">';
		else
			$buf .= '<td class="gt-content-c">';

		$buf .= ($attr->toHtmlInput('gt-content', $seq, $data, $err, $isDisable));
		$buf .= "</td></tr>\n";
		echo $buf;
	}

	function toHtmlInput(&$data, &$err, $seq)
	{
		$this->printHeaderLine(true);

		$keys = array_keys($this->_dattrs);
		foreach( $keys as $i )
		{
			
			$this->printHtmlInputLine($data, $err, $i, $seq, false);
		}
        echo "</table>\n";
	}

	function printHtmlLine1(&$data, &$err, $seq)
	{
		$buf = '<tr class="gt-content">';
		$keys = array_keys($this->_dattrs);
		foreach( $keys as $j )
		{
			$buf .= '<td';
			if ( isset($this->_align[$j]) )
				$buf .= ' align="'.$this->_align[$j] .'"';
			$buf .= '>';
			$attr = &$this->_dattrs[$j];
			$buf .= ($attr->toHtml($data, $err, $seq));
			$buf .= '</td>';
		}
		$buf .= '</tr>'."\n";
		echo $buf;
	}

	function toHtml1(&$data, &$err)
	{
		$this->printHeaderLine(false);
		$row = count($data[$this->_dattrs[0]->_key]);
		for ( $i = 0 ; $i < $row ; ++$i )
		{
			$this->printHtmlLine1($data, $err, $i);
		}
		echo "</table>\n";

	}

	function printHtmlInput1Line(&$data, &$err, $seq, $isDisable)
	{
		$buf = '<tr class="gt-content">';
		$keys = array_keys($this->_dattrs);
		foreach( $keys as $i )
		{
			$attr = &$this->_dattrs[$i];
			if ( $attr->_inputType )
			{
				$buf .= '<td>';
				$buf .= ($attr->toHtmlInput('gt-content',$seq, $data, $err, $isDisable[$i]));
				$buf .= '</td>';
			}
		}
		$buf .= '</tr>'."\n";
		echo $buf;
	}

	/*function dbg_out($tag, &$obj)
	{
		echo "<!-- $tag --\n";
		var_dump($obj);
		echo "-->\n";
	}
	function dbg_tag($tag)
	{
		echo "<!-- $tag -->\n";
	}*/


}

?>
