<?php
require_once 'DTbl.php';
require_once('CustStatusCode.php');

class DTblDef
{
	var $_tblDef = array();

	/*function dbg_out($tag, &$obj)
	{
		echo "<!-- $tag --\n";
		var_dump($obj);
		echo "-->\n";
	}
	function dbg_tag($tag)
	{
		echo "<!-- $tag -->\n";
	}*/

	function &getTblDef($tblId)
	{
		if (! isset( $this->_tblDef[$tblId] ))
		{
			$this->addTblDef($tblId);
		}
		return $this->_tblDef[$tblId];
	}

	function showTitleLabel($label)
	{
		echo '<tr valign="abstop"><td class="label-title">'.$label . '</td></tr>'."\n";
	}

	function addTblDef(&$tblId)
	{
		switch( $tblId )
		{
		case 'SERV_PROCESS': $this->addTblSProcess($tblId); break;
		case 'SERV_GENERAL': $this->addTblSGeneral($tblId); break;
		case 'SERV_LOG': $this->addTblSLog($tblId); break;
		case 'SERV_ACLOG': $this->addTblSACLog($tblId); break;
		case 'SERV_EXPIRES': $this->addTblSExpires($tblId); break;
		case 'A_HTACCESS': $this->addTblHTAccess($tblId); break;
		case 'SERV_TUNING_CONN': $this->addTblSTuningConn($tblId); break;
		case 'SERV_TUNING_REQ': $this->addTblSTuningReq($tblId); break;
		case 'SERV_TUNING_GZIP': $this->addTblSTuningGzip($tblId); break;
		case 'SERV_SEC_FILE': $this->addTblSecFile($tblId); break;
		case 'SERV_SEC_CGI': $this->addTblSecCGI($tblId); break;
		case 'SERV_SEC_CONN': $this->addTblSecConn($tblId); break;
		case 'SERV_SEC_DENY': $this->addTblSecDeny($tblId); break;
		case 'A_SECAC': $this->addTblSecAccessControl($tblId); break;
		case 'A_EXT': $this->addTblExtApp($tblId); break;
		case 'A_SCRIPT': $this->addTblScriptHandler($tblId); break;
		case 'L_GENERAL': $this->addTblListenerGeneral($tblId); break;
		case 'L_VHMAP': $this->addTblListenerVHMap($tblId); break;
		case 'L_CERT': $this->addTblListenerCert($tblId); break;
		case 'L_TOP': $this->addTblListenerTop($tblId); break;
		case 'VH_SECG': $this->addTblVhSecGeneral( $tblId ); break;
		case 'VH_SECHL': $this->addTblVhSecHotlink( $tblId ); break;
		case 'VH_REALM': $this->addTblVhRealm($tblId); break;
		case 'VH_CTXG': 
		case 'VH_CTXJ': 
		case 'VH_CTXS': 
		case 'VH_CTXF': 
		case 'VH_CTXP':
		case 'VH_CTXC': 
		case 'VH_CTXR': 
				$this->addTblVhContext($tblId); 
				break;
		case 'VH_ERRPG': $this->addTblVhErrPage($tblId); break;
		case 'VH_TOP': $this->addTblVhTop($tblId); break;
		case 'VH_GENERAL': $this->addTblVhGeneral($tblId); break;
		case 'VH_EXPIRES': $this->addTblVhExpires($tblId); break;
		case 'VH_LOG': $this->addTblVhLog($tblId); break;
		case 'VH_ACLOG': $this->addTblVhACLog($tblId); break;
		case 'VH_INDXF': $this->addTblVhIndexFile($tblId); break;
		case 'ADMIN_PHP': $this->addTblAdminPhp($tblId); break;
		}
	}

	function addTblAdminPhp($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$titleActionLink = '<a href="javascript:wiz(\'ESadmin\',\'\', \'adminServGeneral1.php\')">Edit</a>';
		$this->_tblDef[$id] = new DTbl($id, 'General', 2, false, $titleActionLink);

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attrs = array(
			new DAttr('enableCoreDump', 'bool', NULL, NULL, 'radio', NULL, 'Enable Core Dump', false),
	
);
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 140;
	}

	function addTblVhTop($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$this->_tblDef[$id] = new DTbl($id, NULL, 2, false, true);

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$options = array( 1=>'Yes', 2=>'If Owner Match', 0=>'No');
		$uidmode = array( 0=>'Server UID', 1=>'CGI File UID', 2=>'DocRoot UID');
		$chrootmode = array( 0=>'Same as Server', 1=>'Virtual Host Root', 2=>'Customized Chroot Path');
		$attrs = array( 
			new DAttr('name', 'name', NULL, NULL, 'text', NULL, 'Virtual Host Name', false),
			new DAttr('vhRoot', 'path', 2, 'rw', 'text', 'size="55"', 'Virtual Host Root', false),
			new DAttr('configFile', 'filep', 3, 'rw', 'text', 'size="55"', 'Config File', false),
			new DAttr('allowSymbolLink', 'sel', 0, $options, 'select', NULL, 'Follow Symbolic Link', true),
			new DAttr('enableScript', 'bool', NULL, NULL, 'radio', NULL, 'Enable Script', false),
			new DAttr('restrained', 'bool', NULL, NULL, 'radio', NULL, 'Restrained', false),
			new DAttr('setUIDMode', 'sel', 2, $uidmode, 'select', NULL, 'CGI Set UID Mode', true),
			new DAttr('chrootMode', 'sel', 0, $chrootmode, 'select', NULL, 'CGI Chroot Mode', true),
			new DAttr('chrootPath', 'path', 3, 'rx', 'text', 'size="55"', 'CGI Chroot Path', true)
			);
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 140;
	}

	function addTblVhErrPage($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$this->_tblDef[$id] = new DTbl($id, 'Customized Error Pages', 3, true, false);

		$status = &CustStatusCode::get();
		$options = array();
		foreach ( $status as $key => $value )
		{
			$options[$key] = "$key  $value";
		}

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attrs = array( 
			new DAttr('errCode', 'sel', 0, $options, 'select', NULL, 'Error Code', false),
			new DAttr('url', 'url', NULL, NULL, 'text', 'size="35"', 'URL', false),
			new DAttr('action', 'cust', NULL, NULL, NULL, NULL, 'Action', false)
			);
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_align = array('left', 'left', 'center');
		$this->_tblDef[$id]->_isMulti = true;
	}

	function addTblScriptHandler($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$this->_tblDef[$id] = new DTbl($id, 'Script Handler Definition', 4, true, false);
		$options = array( 'fcgi'=>'Fast CGI', 'servlet'=>'Servlet Engine', 'proxy'=>'Web Server', 'cgi'=>'CGI');

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attr0 = new DAttr('suffix', 'suffix', NULL, NULL, 'text', NULL, 'Suffix', false);
		$attr0->_multiInd = 1;
		$attrs = array( 
			$attr0,
			new DAttr('type', 'sel', 0, $options, 'select', 'onChange="javascript:document.wizardform.submit()"', 'Handler Type', false),
			new DAttr('handler', 'sel', NULL, NULL, 'select', NULL, 'Handler Name', true),
			new DAttr('action', 'cust', NULL, NULL, NULL, NULL, 'Action', false)
			);
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_align = array('center', 'center', 'left', 'center');
		$this->_tblDef[$id]->_isMulti = true;
	}

	function addTblVhContext($id)
	{
		$attrs = array();
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$this->_tblDef[$id] = new DTbl($id, NULL, 2, false, true);

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attrs['uri'] = new DAttr('uri', 'expuri', NULL, NULL, 'text', 'size="60"', 'URI', false);

		$shandler = new DAttr('handler', 'sel', NULL, NULL, 'select', NULL, 'Servlet Engine', false);

		$enableExpires = new DAttr('enableExpires', 'bool', NULL, NULL, 'radio', NULL, 'Enable Expires', true);
		$enableExpires->_hideNull = true;
		$expiresDefault = new DAttr('expiresDefault', 'parse', "/^[AaMm]\d+$/", '[A|M]###, A means client access time, M means file modified time, ### is number of seconds', 'text', NULL, 'Expires Default', true);
		$expiresDefault->_hideNull = true;


		switch( $id)
		{
		case 'VH_CTXG': 
			$attrs['location'] = new DAttr('location', 'path', 4, 'r', 'text', 'size="60"', 'Root', false);
			$attrs['allowBrowse'] = new DAttr('allowBrowse', 'bool', NULL,NULL, 'radio', NULL, 'Accessible', false);
			$attrs['enableExpires'] = $enableExpires;
			$attrs['expiresDefault'] = $expiresDefault;

			$parseFormat = "/[A-z0-9_\-\.]+\/[A-z0-9_\-\.]+(\s+[A-z0-9_\-]+)+/";
			$parseHelp = 'MIME_type suffix suffix, next MIME_type... MIME type is like text/html, followed by one or more suffix types separated by space. Use comma to separate different MIME types.';
			$addMIMEType = new DAttr('addMIMEType', 'parse', $parseFormat, $parseHelp, 'textarea', 'rows="2" cols="60"', 'MIME Type', true);
			$addMIMEType->_multiInd = 1;
			$addMIMEType->_hideNull = true;
			$parseFormat = "/^([A-z0-9_\-\.]+\/[A-z0-9_\-\.]+)|(NONE)$/i";
			$parseHelp = 'MEME_type like text/html, or put "NONE" to disable inherited Force Type.';
			$forceType = new DAttr('forceType', 'parse', $parseFormat, $parseHelp, 'text', NULL, 'Force MIME Type', true);
			$forceType->_hideNull = true;
			$parseFormat = "/^[A-z0-9_\-\.]+\/[A-z0-9_\-\.]+$/";
			$parseHelp = 'MEME_type like text/html';
			$defaultType = new DAttr('defaultType', 'parse', $parseFormat, $parseHelp, 'text', NULL, 'Default MIME Type', true);
			$defaultType->_hideNull = true;
			$attrs['addMIMEType'] = $addMIMEType;
			$attrs['forceType'] = $forceType;
			$attrs['defaultType'] = $defaultType;

			break;

		case 'VH_CTXJ': 
			$attrs['uri'] = new DAttr('uri', 'uri', NULL, NULL, 'text', 'size="60"', 'URI', false);
			$attrs['location'] = new DAttr('location', 'path', 4, 'r', 'text', 'size="60"', 'Location', false);
			$attrs['handler'] = $shandler;
			$attrs['enableExpires'] = $enableExpires;
			$attrs['expiresDefault'] = $expiresDefault;
			break;

		case 'VH_CTXS': 
			$attrs['handler'] = $shandler;
			break;

		case 'VH_CTXF':
			$attrs['handler'] = new DAttr('handler', 'sel', NULL, NULL, 'select', NULL, 'Fast CGI App', false);
			break;
 
		case 'VH_CTXP':
			$attrs['handler'] = new DAttr('handler', 'sel', NULL, NULL, 'select', NULL, 'Web Server', false);
			break;

		case 'VH_CTXC': 
			$attrs['location'] = new DAttr('location', 'path', 4, 'r', 'text', 'size="60"', 'Path', false);
			$allowSetUID = new DAttr('allowSetUID', 'bool', NULL, NULL, 'radio', NULL, 'Allow Set UID', true);
			$allowSetUID->_hideNull = true;
			$attrs['allowSetUID'] = $allowSetUID;
			break;

		case 'VH_CTXR': 
			$attrs['externalRedirect'] = new DAttr('externalRedirect', 'bool', NULL,NULL, 'radio', 'onClick="chkExternal(this.value)"', 'External Redirect', false);

			$status = &CustStatusCode::get();
			$options = array();
			$options2 = array();
			$options[0] = "";
			$validStatus = array('300', '301','302','303', '305', '307','410');
			foreach ( $status as $key => $value )
			{
				if ( in_array($key, $validStatus) )
					$options[$key] = "$key  $value";
				else
					$options2[$key] = "$key $value";
			}
			foreach( $options as $key => $value )
				$options3[$key] = $value;
			foreach( $options2 as $key => $value )
				$options3[$key] = $value;

			$statusCode = new DAttr('statusCode', 'sel', 0, $options3, 'select', 'onChange="checkStatus()"', 'Status Code', true);
			$statusCode->_hideNull = true;
			$attrs['statusCode'] = $statusCode;

			$attrs['location'] = new DAttr('location', 'url', NULL, NULL, 'text', 'size="60"', 'Destination URI', true);
			break;
		}


		if ( $id !== 'VH_CTXP' )
		{
			$options = array('1'=>'Access Control', '2'=>'Authentication', '4'=>'File Info', '0'=>'None');
			$allowOverride = new DAttr('allowOverride', 'checkboxOr', NULL, $options, 'checkboxgroup', NULL, 'Allow Override', true);
			$allowOverride->_hideNull = true;
			$realm = new DAttr('realm', 'sel', 0, NULL, 'select',  NULL, 'Realm', true);
			$realm->_hideNull = true;
			$authName = new DAttr('authName', 'name', NULL, NULL, 'text', NULL, 'Authentication Name', true);
			$authName->_hideNull = true;
			$required = new DAttr('required', 'cust', NULL, NULL, 'text', NULL, 'Required', true);
			$required->_hideNull = true;
			$allow = new DAttr('accessControl_allow', 'subnet', NULL, NULL, 'textarea', 'rows="3" cols="60"', 'Access Allowed', true);
			$allow->_multiInd = 1;
			$allow->_hideNull = true;
			$deny = new DAttr('accessControl_deny', 'subnet', NULL, NULL, 'textarea', 'rows="3" cols="60"', 'Access Denied', true);
			$deny->_multiInd = 1;
			$deny->_hideNull = true;


			$attrs['allowOverride'] = $allowOverride;
			$attrs['realm'] = $realm;
			$attrs['authName'] = $authName;
			$attrs['required'] = $required;
			$attrs['allow'] = $allow;
			$attrs['deny'] = $deny;
		}

		if ( $id !== 'VH_CTXR' )
		{
			$defaultCharsetOptions = array('off'=>'Off', 'on'=>'On');
			$defaultCharset = new DAttr('addDefaultCharset', 'sel', 0, $defaultCharsetOptions, 'select', NULL, 'Add Default Charset', true);
			$defaultCharset->_hideNull = true;
			$defaultCharsetCustomized = new DAttr('defaultCharsetCustomized', 'cust', NULL, NULL, 'text', NULL, 'Customized Default Charset', true);
			$defaultCharsetCustomized->_hideNull = true;
			$attrs['addDefaultCharset'] = $defaultCharset;
			$attrs['defaultCharsetCustomized'] = $defaultCharsetCustomized;
		}

		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 100;
	}

	function addTblVhRealm($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$this->_tblDef[$id] = new DTbl($id, NULL, 2, false, true);
		$options = array('file' => 'Password File' );

		$userDBLocation = new DAttr('userDB/location', 'file', 3, 'rwc', 'text', 'size="60"', 'User DB Location', false);
	
		$groupDBLocation = new DAttr('groupDB/location', 'file', 3, 'rwc', 'text', 'size="60"', 'Group DB Location', true);


		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attrs = array( 
			0=>new DAttr('name', 'name', NULL, NULL, 'text', 'size="60"', 'Realm Name', false),
			1=>new DAttr('type', 'sel', 0, $options, 'select', NULL, 'DB Type', false),
			2=> $userDBLocation,
			3=>new DAttr('userDB/maxCacheSize', 'uint', 0, '100K', 'text', NULL, 'User DB Max Cache Size', true),
			4=>new DAttr('userDB/cacheTimeout', 'uint', 0, 3600, 'text', NULL, 'User DB Cache Timeout(secs)', true),
			5=>$groupDBLocation,
			6=>new DAttr('groupDB/maxCacheSize', 'uint', 0, '100K', 'text', NULL, 'Group DB Max Cache Size', true),
			7=>new DAttr('groupDB/cacheTimeout', 'uint', 0, 3600, 'text', NULL, 'Group DB Cache Timeout(secs)', true),
			);
		$this->_tblDef[$id]->setDAttr($attrs);
	}

	function addTblExtApp($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$this->_tblDef[$id] = new DTbl($id, NULL, 2, false, true);

		$options = array('fcgi'=>'Fast CGI App', 'servlet'=>'Servlet Engine', 'proxy'=>'Web Server');
		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attr4 = new DAttr('env', 'parse', "/\S+=\S+/", 'PROPERTY=VALUE', 'textarea', 'rows="5" cols="50"', 'Environment', true);
		$attr4->_multiInd = 2;
		$attr4->_htmlName = 'envI';

		$attrs = array( 
			0=>new DAttr('type', 'sel', 0, $options, 'select', 'onChange="toggleType()"', 'Type', false),
			1=>new DAttr('name', 'name', NULL, NULL, 'text', NULL, 'Name', false),
			2=>new DAttr('address', 'addr', NULL, NULL, 'text', 'size="50"', 'Address', false),
			3=>new DAttr('maxConns', 'uint', 0, NULL, 'text', NULL, 'Max Connections', false),
			9=>new DAttr('initTimeout', 'uint', 1, NULL, 'text', NULL, 'Initial Request Timeout (secs)', true),
			10=>new DAttr('retryTimeout', 'uint', 0, NULL, 'text', NULL, 'Retry Timeout (secs)', true),
			4=>$attr4,
			5=>new DAttr('autoStart', 'bool', NULL, NULL, 'radio', 'onClick="toggle(this.value)"', 'Auto Start', true),
			6=>new DAttr('path', 'file', 3, 'x', 'text', 'size="50"', 'Command', true),
			7=>new DAttr('backlog', 'uint', 1, 100, 'text', NULL, 'Back Log', true),
			8=>new DAttr('instances', 'uint', 0, NULL, 'text', NULL, 'Instances', true)
			);
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 150;
	}

	function addTblVhSecGeneral($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$this->_tblDef[$id] = new DTbl($id, 'General', 2, false, NULL);

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attr0 = new DAttr('enableContextAC', 'bool', NULL, NULL, 'radio', NULL, 'Enable Context Access Control', false);
		$attr0->_defaultVal = 0;
		$attrs = array( 
			$attr0
			);
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 200;
	}

	function addTblVhSecHotlink($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$this->_tblDef[$id] = new DTbl($id, 'Hotlink Control', 2, false, NULL);

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attr0 = new DAttr('enableHotlinkCtrl', 'bool', NULL, NULL, 'radio', NULL, 'Enable Hotlink Protection', false);
		$attr0->_defaultVal = 0;
		$attr1 = new DAttr('suffixes', 'suffix', NULL, NULL, 'text', 'size="60"', 'Suffix', false);
		$attr1->_multiInd = 1;
		$attr1->_defaultVal = 'gif,jpeg,jpg,png';
		$attr2 = new DAttr('redirectUri', 'url', NULL, NULL, 'text', 'size="60"', 'Redirect URL', true);
		$attr3 = new DAttr('allowDirectAccess', 'bool', NULL, NULL, 'radio', NULL, 'Allow Direct Access', false);
		$attr3->_defaultVal = 1;
		$attr4 = new DAttr('onlySelf', 'bool', NULL, NULL, 'radio', NULL, 'Only Self Reference', false);
		$attr4->_defaultVal = 1;
		$attr5 = new DAttr('allowedHosts', 'domain', NULL, NULL, 'text', 'size="60"', 'Allowed Domains', true);
		$attr5->_multiInd = 1;
		
		$attrs = array( 
			$attr0,
			$attr1,
			$attr2,
			$attr3,
			$attr4,
			$attr5
			);
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 200;
	}

	function addTblSecAccessControl($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$this->_tblDef[$id] = new DTbl($id, 'Access Control', 1, true, true);

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attr0 = new DAttr('accessControl_allow', 'subnet', NULL, NULL, 'textarea', 'rows="5" cols="78"', 'Allowed List', true);
		$attr0->_multiInd = 1;
		$attr1 = new DAttr('accessControl_deny', 'subnet', NULL, NULL, 'textarea', 'rows="5" cols="78"', 'Denied List', true);
		$attr1->_multiInd = 1;
		$attrs = array( $attr0, $attr1 );
		$this->_tblDef[$id]->setDAttr($attrs);
	}

	function addTblSecDeny($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$titleActionLink = '<a href="javascript:wiz(\'ESsecurity\',\'\', \'servSecurity4.php\')">Edit</a>';
		$this->_tblDef[$id] = new DTbl($id, 'Access Denied Directories', 1, false, $titleActionLink);

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attr = new DAttr('accessDenyDir', 'dir', 2, ',', 'textarea', 'rows="15" cols="78"', NULL, true);
		$attr->_htmlName = 'accessDenyDirI';
		$attr->_multiInd = 2;

		$attrs = array( $attr );
		$this->_tblDef[$id]->setDAttr($attrs);
	}

	function addTblSecFile($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$titleActionLink = '<a href="javascript:wiz(\'ESsecurity\',\'\', \'servSecurity1.php\')">Edit</a>';
		$this->_tblDef[$id] = new DTbl($id, 'File Access Control', 2, false, $titleActionLink);

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$options = array( 1=>'Yes', 2=>'If Owner Match', 0=>'No');
		$attr0 = new DAttr('fileAccessControl/followSymbolLink', 'sel', 0, $options, 'select', NULL, 'Follow Symbolic Link', false);
		$attr1 = new DAttr('fileAccessControl/checkSymbolLink', 'bool', NULL, NULL, 'radio', NULL, 'Check Symbolic Link', false);
		$parseFormat = "/^[0-7]{3,4}/";
		$parseHelp1 = '3 digits or more octet number, Default required permission mask is 004 - readable by everyone';
		$parseHelp2 = '3 digits or more octet number, Default restricted permission mask is 041111 - executable+sticky+directory';
		$attr2 = new DAttr('fileAccessControl/requiredPermissionMask', 'parse', $parseFormat, $parseHelp1, 'text', NULL, 'Required Permission Mask', true);
		$attr3 = new DAttr('fileAccessControl/restrictedPermissionMask', 'parse', $parseFormat, $parseHelp2, 'text', NULL, 'Restricted Permission Mask', true);

		$attrs = array( $attr0, $attr1, $attr2, $attr3 );
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 200;
	}

	function addTblSecCGI($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$titleActionLink = '<a href="javascript:wiz(\'ESsecurity\',\'\', \'servSecurity2.php\')">Edit</a>';
		$this->_tblDef[$id] = new DTbl($id, 'CGI Resource Control', 2, false, $titleActionLink);

		$attrPriority = new DAttr('CGIRLimit/priority', 'uint', -20, 20, 'text', NULL, 'CGI Priority', true);
		$attrPriority->_defaultVal = 10;

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attrs = array( 
			new DAttr('CGIRLimit/maxCGIInstances', 'uint', 1, 2000, 'text', NULL, 'Max CGI Instances', true),
			new DAttr('CGIRLimit/minUID', 'uint', 11, NULL, 'text', NULL, 'Minimum UID', true),
			new DAttr('CGIRLimit/minGID', 'uint', 11, NULL, 'text', NULL, 'Minimum GID', true),
			$attrPriority,
			new DAttr('CGIRLimit/CPUSoftLimit', 'uint', 0, NULL, 'text', NULL, 'CPU Soft Limit (sec)', true),
			new DAttr('CGIRLimit/CPUHardLimit', 'uint', 0, NULL, 'text', NULL, 'CPU Hard Limit (sec)', true),
			new DAttr('CGIRLimit/memSoftLimit', 'uint', 0, NULL, 'text', NULL, 'Memory Soft Limit (bytes)', true),
			new DAttr('CGIRLimit/memHardLimit', 'uint', 0, NULL, 'text', NULL, 'Memory Hard Limit (bytes)', true),
			new DAttr('CGIRLimit/procSoftLimit', 'uint', 0, NULL, 'text', NULL, 'Process Soft Limit', true),
			new DAttr('CGIRLimit/procHardLimit', 'uint', 0, NULL, 'text', NULL, 'Process Hard Limit', true)
			);
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 200;
	}

	function addTblSecConn($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$titleActionLink = '<a href="javascript:wiz(\'ESsecurity\',\'\', \'servSecurity5.php\')">Edit</a>';
		$this->_tblDef[$id] = new DTbl($id, 'Per Client Connection Control', 2, false, $titleActionLink);

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attrs = array( 
			new DAttr('perClientConnLimit/throttleLimit', 'uint', 0, NULL, 'text', NULL, 'Throttle Limit (bytes/sec)', true),
			new DAttr('perClientConnLimit/softLimit', 'uint', 0, NULL, 'text', NULL, 'Connection Soft Limit', true),
			new DAttr('perClientConnLimit/hardLimit', 'uint', 0, NULL, 'text', NULL, 'Connection Hard Limit', true),
			new DAttr('perClientConnLimit/gracePeriod', 'uint', 1, 3600, 'text', NULL, 'Grace Period (sec)', true),
			new DAttr('perClientConnLimit/banPeriod', 'uint', 0, NULL, 'text', NULL, 'Banned Period (sec)', true),
			
			);
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 200;
	}

	function addTblHTAccess($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$this->_tblDef[$id] = new DTbl($id, 'HT Access', 2, false, true);

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$options = array('1'=>'Access Control', '2'=>'Authentication', '4'=>'File Info', '0'=>'None');
		$attr0 = new DAttr('allowOverride', 'checkboxOr', NULL, $options, 'checkboxgroup', NULL, 'Allow Override', true);
		$attrs = array( $attr0,
			new DAttr('accessFileName', 'accf', NULL, NULL, 'text', NULL, 'Access File Name', true) );

		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 140;
	}

	function addTblSGeneral($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$titleActionLink = '<a href="javascript:wiz(\'ESgeneral\',\'\', \'servGeneral2.php\')">Edit</a>';
		$this->_tblDef[$id] = new DTbl($id, 'General Settings', 2, false, $titleActionLink);

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attr0 = new DAttr('mime', 'file', 2, 'rw', 'text', 'size="78"', 'MIME Settings', false);
		$attr0->_href = '"javascript:wiz(\'ESmime\',\'\',\'servMime.php\')"';
		$attr1 = new DAttr('indexFiles', 'fname', NULL, NULL, 'textarea', 'rows="5" cols="78"', 'Index Files', false);
		$attr1->_multiInd = 1;
		$attr2 = new DAttr('adminEmails', 'email', NULL, NULL, 'textarea', 'rows="3" cols="78"', 'Administrator Email', true);
		$attr2->_multiInd = 1;

		$attr3 = new DAttr('showVersionNumber', 'bool', NULL, NULL, 'radio', NULL, 'Show Server Version', false);
		$attr3->_defaultVal = 0;

		$attrs = array( $attr0, $attr1, $attr3, $attr2 );
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 140;
	}

	function addTblVhIndexFile($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$this->_tblDef[$id] = new DTbl($id, 'Index Files', 2, false, NULL);
		$options = array(0=>'No', 1=>'Yes', 2=>'Addition');

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attr1 = new DAttr('indexFiles', 'fname', NULL, NULL, 'textarea', 'rows="5" cols="78"', 'VHost Setting', true);
		$attr1->_multiInd = 1;
		$attrs = array( 
			new DAttr('indexFiles_useServer', 'sel', 0, $options, 'select', 'onChange="javascript:useServer(this.value)"', 'Use Server Setting', false),
			$attr1
			);
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 140;
	}

	function addTblVhGeneral($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$this->_tblDef[$id] = new DTbl($id, 'General', 2, false, NULL);

		$attr2 = new DAttr('adminEmails', 'email', NULL, NULL, 'textarea', 'rows="3" cols="78"', 'Administrator Email', true);
		$attr2->_multiInd = 1;

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attrs = array(
			new DAttr('docRoot', 'path', 3, 'r', 'text', 'size="78"', 'Document Root', false) ,
			new DAttr('enableGzip', 'bool', NULL, NULL, 'radio', NULL, 'Enable GZIP', true),
			$attr2 );
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 140;
	}

	function addTblVhACLog($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$this->_tblDef[$id] = new DTbl($id, 'Access Log', 2, false, NULL);
		$use_options = array(0=>'Own Log File', 1=>'Server\'s Log File', 2=>'Disabled');

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attrs = array( 
			new DAttr('accessLog_useServer', 'sel', 0, $use_options, 'select', 'onChange="javascript:useServer(this.value)"', 'Log Control', false),
			new DAttr('accessLog_fileName', 'filep', 3, 'rw', 'text', 'size="60"', 'File Name', true),
			new DAttr('accessLog_logReferer', 'bool', NULL, NULL, 'radio', NULL, 'Log Referrer', true),
			new DAttr('accessLog_logUserAgent', 'bool', NULL, NULL, 'radio', NULL, 'Log User Agent', true),
			new DAttr('accessLog_rollingSize', 'uint', 0, '1G', 'text', NULL, 'Rolling Size(bytes)', true),
			new DAttr('accessLog_keepDays', 'uint', 0, NULL, 'text', NULL, 'Keep Days', true)
			);
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 140;
	}

	function addTblVhLog($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$this->_tblDef[$id] = new DTbl($id, 'Virtual Host Log', 2, false, NULL);
		$log_options = array('ERROR'=>'ERROR', 'WARN'=>'WARNING',
						   'NOTICE'=>'NOTICE', 'INFO'=>'INFO', 'DEBUG'=>'DEBUG');
		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attrs = array( 
			new DAttr('log_useServer', 'bool', NULL, NULL, 'radio', 'onClick="javascript:useServer(this.value)"', 'Use Server\'s Log', false),
			new DAttr('log_fileName', 'filep', 3, 'rw', 'text', 'size="60"', 'File Name', true),
			new DAttr('log_logLevel', 'sel', 0, $log_options, 'select', NULL, 'Log Level', true),
			new DAttr('log_rollingSize', 'uint', 0, '1G', 'text', NULL, 'Rolling Size(bytes)', true)
			);
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 140;
	}

	function addTblSACLog($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$titleActionLink = '<a href="javascript:wiz(\'ESgeneral\',\'\', \'servGeneral4.php\')">Edit</a>';
		$this->_tblDef[$id] = new DTbl($id, 'Access Log', 2, false, $titleActionLink);

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attrs = array( 
			new DAttr('accessLog_fileName', 'filep', 2, 'rw', 'text', 'size="60"', 'File Name', false),
			new DAttr('accessLog_logReferer', 'bool', NULL, NULL, 'radio', NULL, 'Log Referrer', true),
			new DAttr('accessLog_logUserAgent', 'bool', NULL, NULL, 'radio', NULL, 'Log User Agent', true),
			new DAttr('accessLog_rollingSize', 'uint', 0, '1G', 'text', NULL, 'Rolling Size(bytes)', true),
			new DAttr('accessLog_keepDays', 'uint', 0, NULL, 'text', NULL, 'Keep Days', true)
			);
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 140;
	}

	function addTblSExpires($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$this->_tblDef[$id] = new DTbl($id, 'Expires Settings', 2, false, true);

		$parseFormat = "/^(\*\/\*)|([A-z0-9_\-\.]+\/\*)|([A-z0-9_\-\.]+\/[A-z0-9_\-\.]+)=[AaMm]\d+$/";
		$parseHelp = 'MIME_type=A|Mseconds, MIME type can be like */*, text/*, text/html';
		$attr2 = new DAttr('expiresByType', 'parse', $parseFormat, $parseHelp, 'textarea', 'rows="5" cols="50"', 'Expires By Type', true);
		$attr2->_multiInd = 1;

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attrs = array( 
			new DAttr('enableExpires', 'bool', NULL, NULL, 'radio', NULL, 'Enable Expires', true),
			new DAttr('expiresDefault', 'parse', "/^[AaMm]\d+$/", '[A|M]###, A means client access time, M means file modified time, ### is number of seconds', 'text', NULL, 'Expires Default', true),
			$attr2);
	
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 140;

	}

	function addTblVhExpires($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$this->_tblDef[$id] = new DTbl($id, 'Expires Settings', 2, false, true);

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attrs = array( 
			new DAttr('enableExpires', 'bool', NULL, NULL, 'radio', NULL, 'Enable Expires', true),
			new DAttr('expiresDefault', 'parse', "/^[AaMm]\d+$/", '[A|M]###, A means client access time, M means file modified time, ### is number of seconds', 'text', NULL, 'Expires Default', true));
	
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 140;

	}

	function addTblSLog($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$titleActionLink = '<a href="javascript:wiz(\'ESgeneral\',\'\', \'servGeneral3.php\')">Edit</a>';
		$this->_tblDef[$id] = new DTbl($id, 'Server Log', 2, false, $titleActionLink);

		$log_options = array('ERROR'=>'ERROR', 'WARN'=>'WARNING',
						   'NOTICE'=>'NOTICE', 'INFO'=>'INFO', 'DEBUG'=>'DEBUG');
		$dbg_options = array('10'=>'HIGH', '5'=>'MEDIUM', '2'=>'LOW', '0'=>'NONE');
		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attrs = array( 
			new DAttr('log_fileName', 'filep', 2, 'rw', 'text', 'size="60"', 'File Name', false),
			new DAttr('log_logLevel', 'sel', 0, $log_options, 'select', 'onChange="updDbgLevel(0)"', 'Log Level', false),
			new DAttr('log_debugLevel', 'sel', 0, $dbg_options, 'select', 'onChange="updDbgLevel(1)"', 'Debug Level', false),
			new DAttr('log_rollingSize', 'uint', 0, '1G', 'text', NULL, 'Rolling Size(bytes)', true),
			new DAttr('log_enableStderrLog', 'bool', NULL, NULL, 'radio', NULL, 'Enable stderr Log', true),
			);
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 140;
	}

	function addTblSProcess($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$titleActionLink = '<a href="javascript:wiz(\'ESgeneral\',\'\', \'servGeneral1.php\')">Edit</a>';
		$this->_tblDef[$id] = new DTbl($id, 'Server Process', 2, false, $titleActionLink);

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attr1 = new DAttr('autoRestart', 'bool', NULL, NULL, 'radio', NULL, 'Auto Restart', false);
		$attr1->_defaultVal = 1;
		$attr2 = new DAttr('enableChroot', 'bool', NULL, NULL, 'radio', NULL, 'Enable chroot', false);
		$attr2->_defaultVal = 0;
		$attr2->_version = 1;

		$attr3 = new DAttr('chrootPath', 'cust', NULL, NULL, 'text', 'size="60" readonly', 'chroot Path', true);
		$attr3->_version = 1;

		$attr4 = new DAttr('priority', 'uint', -20, 20, 'text', NULL, 'Priority', true);
		$attr4->_defaultVal = 3;

		$attrs = array( 
			new DAttr('serverName', 'name', NULL, NULL, 'text', NULL, 'Server Name', false),
			new DAttr('runningAs', 'cust', NULL, NULL, 'text', 'size="60" readonly', 'Running As', false),
			$attr4,
			$attr3, $attr2,
			new DAttr('inMemBufSize', 'uint', 0, NULL, 'text', NULL, 'Max I/O Buffer Size', false),
			new DAttr('swappingDir', 'path', 1, 'rw', 'text', 'size="60"', 'Swapping Directory', false),
			$attr1
			);
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 140;
	}

	function addTblListenerTop($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$this->_tblDef[$id] = new DTbl($id, 'Listener List', 5, true, false);
		$options = &$this->getIPOptions();

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attrs = array( 
			new DAttr('name', 'name', NULL, NULL, NULL, NULL, 'Listener Name', false),
			new DAttr('ip', 'sel', NULL, $options, NULL, NULL, 'IP Address', false),
			new DAttr('port', 'uint', 1, 65535, NULL, NULL, 'Port', false),
			new DAttr('secure', 'bool', NULL, NULL, NULL, NULL, 'Secure', false),
			new DAttr('action', 'cust', NULL, NULL, NULL, NULL, 'Action', false)
			);
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_isMulti = true;
		$this->_tblDef[$id]->_align = array('center', 'center', 'center', 'center', 'center');
	}

	function addTblListenerVHMap($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$this->_tblDef[$id] = new DTbl($id, 'Virtual Host Mappings', 2, true, true);

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attr1 = new DAttr('domain', 'domain', NULL, NULL, 'text', 'size="60"', 'Domains', false);
		$attr1->_multiInd = 1;
		$attrs = array( 
			new DAttr('vh', 'checkbox', NULL, NULL, 'checkbox', NULL, 'Virtual Host', false),
			$attr1
			);
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_isMulti = true;
		$this->_tblDef[$id]->_labelWid = 140;
	}

	function &getIPOptions()
	{
		$options = array();
		$options['ANY'] = 'ANY';
		$ips = explode(',', $_SERVER['IPV4_ADDRS']);
		foreach( $ips as $ip )
		{
			$pos = strpos($ip, ':');
			if ( $pos )
			{
				$aip = substr($ip, $pos+1);
				$options[$aip] = $aip;
			}
		}
		return $options;
	}

	function addTblListenerGeneral($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$this->_tblDef[$id] = new DTbl($id, 'Address Settings', 2, false, true);

		$options = &$this->getIPOptions();
		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attrs = array( 
			new DAttr('name', 'name', NULL, NULL, 'text', NULL, 'Listener Name', false),
			new DAttr('ip', 'sel', 0, $options, 'select', NULL, 'IP Address', false),
			new DAttr('port', 'uint', 0, 65535, 'text', NULL, 'Port', false),
			new DAttr('secure', 'bool', NULL, NULL, 'radio', NULL, 'Secure', false)
			);
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 140;
		$this->_tblDef[$id]->_align = array('center', 'left');
	}

	function addTblListenerCert($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$this->_tblDef[$id] = new DTbl($id, 'SSL Key & Certificate', 2, false, true);

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attrs = array( 
			new DAttr('certFile', 'file', 2, 'r', 'text', 'size="70"', 'Cert File', false),
			new DAttr('keyFile', 'file', 2, 'r', 'text', 'size="70"', 'Key File', false)
			);
		$this->_tblDef[$id]->setDAttr($attrs);
	}

	function addTblSTuningConn($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$titleActionLink = '<a href="javascript:wiz(\'EStuning\',\'\', \'servTuning1.php\')">Edit</a>';
		$this->_tblDef[$id] = new DTbl($id, 'Connection Tuning', 2, false, $titleActionLink);

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attrs = array( 
			new DAttr('maxConnections', 'uint', 0, NULL, 'text', NULL, 'Max Connections', false),
			new DAttr('maxSSLConnections', 'uint', 0, NULL, 'text', NULL, 'Max SSL Connections', false),
			new DAttr('connTimeout', 'uint', 10, 600, 'text', NULL, 'Connection Timeout (secs)', false),
			new DAttr('maxKeepAliveReq', 'uint', 0, NULL, 'text', NULL, 'Max Keep-Alive Requests', false),
			new DAttr('keepAliveTimeout', 'uint', 0, 60, 'text', NULL, 'Keep-Alive Timeout (secs)', false),
			new DAttr('sndBufSize', 'uint', 0, 65535, 'text', NULL, 'Send Buffer Size (bytes)', false),
			new DAttr('rcvBufSize', 'uint', 0, 65535, 'text', NULL, 'Receive Buffer Size (bytes)', false),
			);
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 290;

	}

	function addTblSTuningReq($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$titleActionLink = '<a href="javascript:wiz(\'EStuning\',\'\', \'servTuning2.php\')">Edit</a>';
		$this->_tblDef[$id] = new DTbl($id, 'Request/Response Tuning', 2, false, $titleActionLink);

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attrs = array( 
			new DAttr('maxReqURLLen', 'uint', 200, 8192, 'text', NULL, 'Max Request URL Length (bytes)', false),
			new DAttr('maxReqHeaderSize', 'uint', 512, 16380, 'text', NULL, 'Max Request Header Size (bytes)', false),
			new DAttr('maxReqBodySize', 'uint', '1M', '1G', 'text', NULL, 'Max Request Body Size (bytes)', false),
			new DAttr('maxDynRespHeaderSize', 'uint', 200, 8192, 'text', NULL, 'Max Dynamic Response Header Size (bytes)', false), 
			new DAttr('maxDynRespSize', 'uint', '1M', '1G', 'text', NULL, 'Max Dynamic Response Body Size (bytes)', false), 
			);
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 290;

	}

	function addTblSTuningGzip($id)
	{
		//($id, $titleCenter, $cols, $showHeader, $titleActionLink)
		$titleActionLink = '<a href="javascript:wiz(\'EStuning\',\'\', \'servTuning3.php\')">Edit</a>';
		$this->_tblDef[$id] = new DTbl($id, 'GZIP Compression Tuning', 2, false, $titleActionLink);

		$parseFormat = "/^(\!)?(\*\/\*)|([A-z0-9_\-\.]+\/\*)|([A-z0-9_\-\.]+\/[A-z0-9_\-\.]+)$/";
		$parseHelp = '(!)MIME types, like */*, text/*, text/html, text/*, !text/css';
		$attr3 = new DAttr('compressibleTypes', 'parse', $parseFormat, $parseHelp, 'textarea', 'rows="5" cols="50"', 'Compressible Types', true);
		$attr3->_multiInd = 1;

		//($key, $type, $min, $max, $inputType, $inputAttr, $label, $allowNull)
		$attrs = array( 
			new DAttr('enableGzipCompress', 'bool', NULL, NULL, 'radio', NULL, 'Enable Compression', false),
			new DAttr('enableDynGzipCompress', 'bool', NULL, NULL, 'radio', NULL, 'Enable Dynamic Compression', false),
			new DAttr('gzipCompressLevel', 'uint', 1, 9, 'text', NULL, 'Compression Level (Dynamic Content)', true),
			$attr3,
			new DAttr('gzipAutoUpdateStatic', 'bool', NULL, NULL, 'radio', NULL, 'Auto Update Static', true),
			new DAttr('gzipStaticCompressLevel', 'uint', 1, 9, 'text', NULL, 'Compression Level (Static File)', true),
			new DAttr('gzipMaxFileSize', 'uint', '1K', NULL, 'text', NULL, 'Max Static File Size (bytes)', true),
			new DAttr('gzipMinFileSize', 'uint', 200, NULL, 'text', NULL, 'Min Static File Size (bytes)', true),
			);
		$this->_tblDef[$id]->setDAttr($attrs);
		$this->_tblDef[$id]->_labelWid = 290;

	}

}

?>