<?php
require_once('DTblDef.php');

class ValidateData
{
	function &getTableDef()
	{
		if ( !isset($GLOBALS['_DTblDef_']) )
			$GLOBALS['_DTblDef_'] = new DTblDef();
		$tblDef = &$GLOBALS['_DTblDef_'];
		return $tblDef;
	}

	function extract($tids, &$from, &$to, &$err)
	{
		$tblDef = &$this->getTableDef();
		if ( is_array( $tids ) )
		{
			$goFlag = 1;
			foreach ( $tids as $tid )
			{
				$table = $tblDef->getTblDef($tid);
				$go = $table->extractValue($from, $to, $err);
				if ( $go < 0 )
					$goFlag = -1;
			}
		}
		else
		{
			$table = $tblDef->getTblDef($tids);
			$goFlag = $table->extractValue($from, $to, $err);
		}
		return $goFlag;
	}

	function validate($tids, &$to, &$err, &$attr)
	{
		$tblDef = &$this->getTableDef();
		if ( is_array( $tids ) )
		{
			$isValid = true;
			foreach ( $tids as $tid )
			{
				$isValid1 = $this->check($tid, $to, $err, $attr);
				$isValid = $isValid && $isValid1;
			}
		}
		else
		{
			$isValid = $this->check($tids, $to, $err, $attr);
		}
		return $isValid;
	}

	function check($tid, &$to, &$err, &$attr)
	{
		switch( $tid )
		{
		case 'A_EXT': return $this->chkExtApp($to, $err, $attr); 
		case 'A_SCRIPT': return $this->chkScriptHandler($to, $err, $attr);

		case 'L_GENERAL':
		case 'VH_TOP': 
		case 'VH_REALM': return $this->chkDups( $to, $err, $attr['names'], 'name');
		case 'VH_ERRPG': return $this->chkDups( $to, $err, $attr['names'], 'errCode');
		case 'VH_CTXG': 
		case 'VH_CTXJ': 
		case 'VH_CTXS': 
		case 'VH_CTXF': 
		case 'VH_CTXC': 
		case 'VH_CTXR': return $this->chkDups( $to, $err, $attr['names'], 'uri');
		}
		return true;
	}

	function chkDups(&$to, &$err, &$checkList, $key)
	{
		if ( in_array( $to[$key], $checkList ) )
		{
			$err[$key] = 'This ' . $key . ' "' . $to[$key] . '" has been used, please enter a different one.';
			return false;
		}
		return true;
	}

	function chkExtApp(&$to, &$err, &$attr)
	{
		$isValid = true;
		if ( $to['autoStart'] )
		{
			if ( $to['path'] == NULL )
			{
				$err['path'] = 'must provide path when autoStart enabled';
				$isValid = false;
			}
			if ( $to['backlog'] == NULL )
			{
				$err['backlog'] = 'must input backlog when autoStart enabled';
				$isValid = false;
			}
			if ( $to['instances'] == NULL )
			{
				$err['instances'] = 'must give number of instances when autoStart enabled';
				$isValid = false;
			}

		}
		else
		{
			unset( $to['path'] );
			unset( $to['backlog'] );
			unset( $to['instances'] );
			unset( $err['path'] );
			unset( $err['backlog'] );
			unset( $err['instances'] );
		}

		if ( isset($attr['names']) && (!$this->chkDups($to, $err, $attr['names'], 'name')) )
		{
			$isValid = false;
		}
		return $isValid;
	}

	function chkScriptHandler(&$to, &$err, &$attr)
	{
		$vals = DAttr::splitMultiple( $to['suffix'] );
		$isValid = true;
		foreach( $vals as $suffix )
		{
			if ( in_array( $suffix, $attr['names'] ) )
			{
				$t[] = $suffix; 
				$isValid = false;
			}
		}
		if ( !$isValid )
			$err['suffix'] .= ' Suffix ' . implode(', ', $t) . ' has been set; you must use a different one or modify the existing one.';
		return $isValid;
	}

	/*function dbg_out($tag, &$obj)
	{
		echo "<!-- $tag --\n";
		var_dump($obj);
		echo "-->\n";
	}
	function dbg_tag($tag)
	{
		echo "<!-- $tag -->\n";
	}*/

}

?>
