<?php
require_once('ConfManager.php');
require_once('ValidateData.php');

class Wizard
{
	var $_actType;
	var $_tag;
	var $_objName;
	var $_objId;
	var $_subId;
	var $_finishPage;
	var $_parentWin;


	var $_temp;
	var $_tempErr;
	var $_attr;

	function init(&$confMgr, $objName, $objId, $finishPage, $parentWin)
	{
		$this->_actType = $objName{0};
		$this->_tag = $objName{1};
		$this->_objName = substr($objName, 2);
		$this->_objId = $objId;
		$this->_finishPage = $finishPage;
		$this->_parentWin = $parentWin;
		$this->_temp = NULL;
		$this->_tempErr = NULL;
		$this->_attr = NULL;
		$this->_subId = NULL;

		if ( $this->_actType === 'E' )
		{
			if ( $this->_tag === 'V' )
				$this->initVhEdit($confMgr);
			else
				$this->initServEdit($confMgr);
		}
		elseif ( $this->_actType === 'A' )
		{
			if ( $this->_tag === 'V' )
				$this->initVhAdd($confMgr);
			else
				$this->initServAdd($confMgr);
		}
	}

	function initServEdit(&$confMgr)
	{	
		if ( $this->_tag === 'S' )
		{
			if ( $this->_objName === 'admin' )
			{
				$this->_temp = $confMgr->_serv;
				$this->_tempErr = $confMgr->_servErr;
			}
			elseif ( $this->_objName === 'general'
					 || $this->_objName === 'tuning'
					 || $this->_objName === 'security' )
			{
				$this->_temp = $confMgr->_serv[$this->_objName];
				$this->_tempErr = $confMgr->_servErr[$this->_objName];
			}
			elseif ( $this->_objName === 'ext' )
			{
				$this->_temp = $confMgr->_serv['ext'][$this->_objId];
				$this->_tempErr = $confMgr->_servErr['ext'][$this->_objId];
				$this->_attr['names'] = &$confMgr->getServNames( 'ext', $this->_objId );
			}
			elseif ( $this->_objName === 'scr' )
			{
				$this->_temp = $confMgr->_serv['scriptHandler'][$this->_objId];
				$this->_tempErr = $confMgr->_servErr['scriptHandler'][$this->_objId];

				$this->_attr['handlers'] = $confMgr->_serv['servletHandlers'];
				$this->_attr['fhandlers'] = $confMgr->_serv['fcgiHandlers'];
				$this->_attr['phandlers'] = $confMgr->_serv['webServers'];
				$this->_attr['names'] = &$confMgr->getServNames( 'scr', $this->_objId );
			}
			elseif ( $this->_objName === 'mime' )
			{
				$this->_temp = &$confMgr->loadMime();
			}
			elseif ( $this->_objName === 'vh' )
			{
				$this->_temp = $confMgr->_serv['vhTop'][$this->_objId];
				$this->_tempErr = $confMgr->_servErr['vhTop'][$this->_objId];
				$this->_attr['names'] = &$confMgr->getServNames( 'vhTop', $this->_objId );
			}
		}
		elseif ( $this->_tag === 'L' )
		{
			$this->_temp = $confMgr->_serv['listeners'][$this->_objId];
			$this->_tempErr = $confMgr->_servErr['listeners'][$this->_objId];
			$this->_attr['names'] = &$confMgr->getServNames( 'listeners', $this->_objId );
		}
	}

	function initServAdd(&$confMgr)
	{
		if ( $this->_tag === 'L' )
		{
			$this->_attr['names'] = &$confMgr->getServNames( 'listeners', NULL );
		}
		elseif ( $this->_objName === 'scr' )
		{
			$this->_attr['handlers'] = $confMgr->_serv['servletHandlers'];
			$this->_attr['fhandlers'] = $confMgr->_serv['fcgiHandlers'];
			$this->_attr['phandlers'] = $confMgr->_serv['webServers'];
			$this->_attr['names'] = &$confMgr->getServNames( 'scr', NULL );
		}
		elseif ( $this->_objName === 'ext' )
		{
			$this->_attr['names'] = &$confMgr->getServNames( 'ext', NULL );
		}
		elseif ( $this->_objName === 'vh' )
		{
			$this->_attr['names'] = &$confMgr->getServNames( 'vhTop', NULL );
		}

	}	

	function initVhEdit(&$confMgr)
	{
		$vh = &$confMgr->_vhosts[$this->_objId];
		$vhErr = &$confMgr->_vhostsErr[$this->_objId];
		$objn = substr($this->_objName,0,3);
		$this->_attr['VH_ROOT'] = $vh['VH_ROOT'];
		$this->_attr['DOC_ROOT'] = $vh['DOC_ROOT'];

		if ( $this->_objName === 'general' )
		{
			$this->_temp = $vh[$this->_objName];
			$this->_tempErr = $vhErr[$this->_objName];
		}
		elseif ( $this->_objName === 'secac' )
		{
			$this->_temp = $vh['security']['accessControl'];
			$this->_tempErr = $vhErr['security']['accessControl'];
		}
		elseif ( $this->_objName === 'secg' )
		{
			$this->_temp = $vh['security']['general'];
			$this->_tempErr = $vhErr['security']['general'];
		}
		elseif ( $this->_objName === 'sechl' )
		{
			$this->_temp = $vh['security']['hotlink'];
			$this->_tempErr = $vhErr['security']['hotlink'];
		}
		elseif ( $objn === 'err' )
		{
			$this->_subId = substr( $this->_objName, 3);
			$this->_objName = 'err';
			$this->_temp = $vh['errUrl'][$this->_subId];
			$this->_tempErr = $vhErr['errUrl'][$this->_subId];
			$this->_attr['names'] = &$confMgr->getVhNames( 'err', $vh, $this->_subId );
		}
		elseif ( $objn === 'hta' )
		{
			$this->_subId = substr( $this->_objName, 3);
			$this->_objName = 'hta';
			$this->_temp = $vh['security']['realm'][$this->_subId];
			$this->_tempErr = $vhErr['security']['realm'][$this->_subId];
			$this->_attr['names'] = &$confMgr->getVhNames( 'hta', $vh, $this->_subId );
		}
		elseif ( $objn === 'udb' )
		{
			$this->_subId = substr( $this->_objName, 3);
			$this->_objName = 'udb';
			$this->_temp = &$confMgr->loadUserDB($this->_objId, $this->_subId);
		}
		elseif ( $objn === 'gdb' )
		{
			$this->_subId = substr( $this->_objName, 3);
			$this->_objName = 'gdb';
			$this->_temp = &$confMgr->loadGroupDB($this->_objId, $this->_subId);
		}
		elseif ( $objn === 'scr' )
		{
			$this->_subId = substr($this->_objName, 3);
			$this->_objName = 'scr';
			$this->_temp = $vh['scriptHandler'][$this->_subId];
			$this->_tempErr = $vhErr['scriptHandler'][$this->_subId];

			$confMgr->refreshExtApp($this->_objId, $vh);
			$this->_attr['handlers'] = $vh['servletHandlers'];
			$this->_attr['fhandlers'] = $vh['fcgiHandlers'];
			$this->_attr['phandlers'] = $vh['webServers'];
			$this->_attr['names'] = &$confMgr->getVhNames( 'scr', $vh, $this->_subId );
		}
		elseif ( $objn === 'ext' )
		{
			$this->_subId = substr($this->_objName,3);
			$this->_objName = 'ext';
			$this->_temp = $vh['ext'][$this->_subId];
			$this->_tempErr = $vhErr['ext'][$this->_subId];
			$this->_attr['names'] = &$confMgr->getVhNames( 'ext', $vh, $this->_subId );
		}
		elseif ( $objn === 'ctx' )
		{
			$type = $this->_objName{3};
			$t = $this->getContextTypeByCode($type);
			$this->_subId = substr($this->_objName,4);
			$this->_objName = substr($this->_objName, 0, 4);
			$this->_temp = $vh['context'][$t][$this->_subId];
			$this->_tempErr = $vhErr['context'][$t][$this->_subId];
			$this->_finishPage .= '&tid=VH_CTX' . ucfirst($type);
			$this->_attr['realms'] = $vh['realms'];
			if ( $type === 'j' || $type === 's' )
				$this->_attr['handlers'] = $vh['servletHandlers'];
			elseif ( $type === 'f' )
				$this->_attr['handlers'] = $vh['fcgiHandlers'];
			elseif ( $type === 'p' )
				$this->_attr['handlers'] = $vh['webServers'];
			$this->_attr['names'] = &$confMgr->getVhNames( 'ctx', $vh, $this->_subId );
		}
	}

	function initVhAdd(&$confMgr)
	{
		$vh = &$confMgr->_vhosts[$this->_objId];
		$objn = substr($this->_objName,0,3);
		$this->_attr['VH_ROOT'] = $vh['VH_ROOT'];
		$this->_attr['DOC_ROOT'] = $vh['DOC_ROOT'];
		if ( $objn === 'ctx' )
		{
			$type = $this->_objName{3};
			$this->_finishPage .= '&tid=VH_CTX' . ucfirst($type);
			$this->_objName = substr($this->_objName, 0, 4);

			$this->_temp['type'] = $this->getContextTypeByCode($type);

			$this->_attr['realms'] = $vh['realms'];
			if ( $type === 'j' || $type === 's' )
				$this->_attr['handlers'] = $vh['servletHandlers'];
			elseif ( $type === 'f' )
				$this->_attr['handlers'] = $vh['fcgiHandlers'];
			elseif ( $type === 'p' )
				$this->_attr['handlers'] = $vh['webServers'];
			$this->_attr['names'] = &$confMgr->getVhNames( 'ctx', $vh, NULL );
		}
		elseif ( $objn === 'scr' )
		{
			$this->_objName = $objn;
			$confMgr->refreshExtApp($this->_objId, $vh);
			$this->_attr['handlers'] = $vh['servletHandlers'];
			$this->_attr['fhandlers'] = $vh['fcgiHandlers'];
			$this->_attr['phandlers'] = $vh['webServers'];
			$this->_attr['names'] = &$confMgr->getVhNames( 'scr', $vh, NULL );
		}
		elseif ( $objn === 'hta' || $objn === 'err' || $objn === 'ext' )
		{
			$this->_objName = $objn;
			$this->_attr['names'] = &$confMgr->getVhNames( $objn, $vh, NULL );
		}
	}	

	function finish($fromPage, &$confMgr)
	{
		$go = 0;
		if ( $fromPage == 'servMime.php' )
		{
			$go = $confMgr->saveMime($this->_temp);
		}
		elseif ( $fromPage == 'userDB1.php' )
		{
			$go = $confMgr->saveUserDB($this->_temp, $this->_objId, $this->_subId);
		}
		elseif ( $fromPage == 'groupDB1.php' )
		{
			$go = $confMgr->saveGroupDB($this->_temp, $this->_objId, $this->_subId);
		}
		else
		{
			$updateMenu = $this->saveValue($confMgr, $fromPage);
			if ( $this->_tag === 'V' )
				$go = $confMgr->saveVhFile($this->_objId);
			else
				$go = $confMgr->saveServFile($updateMenu);
		}
		return 1; //$go;
	}

	function saveValue(&$confMgr, $fromPage)
	{
		if ( $this->_tag === 'S' )
			return $this->saveServValue($confMgr, $fromPage);
		elseif ( $this->_tag === 'L' )
			return $this->saveListenerValue($confMgr);
		elseif ( $this->_tag === 'V' )
			return $this->saveVhostValue($confMgr);
	}

	function saveServValue(&$confMgr, $fromPage)
	{
		$updateMenu = false;
		if ( $this->_objName === 'admin' )
		{
			$confMgr->_serv = $this->_temp;
			$confMgr->_servErr = $this->_tempErr;
		}
		elseif ( $this->_objName === 'general' )
		{
			$confMgr->_serv['general'] = $this->_temp;
			$confMgr->_servErr['general'] = $this->_tempErr;
		}
		elseif ( $this->_objName === 'tuning' )
		{
			$confMgr->_serv['tuning'] = $this->_temp;
			$confMgr->_servErr['tuning'] = $this->_tempErr;
		}
		elseif ( $this->_objName === 'security' )
		{
			$confMgr->_serv['security'] = $this->_temp;
			$confMgr->_servErr['security'] = $this->_tempErr;
		}
		elseif ( $this->_objName === 'ext' )
		{
			$oldName = $this->_objId;
			$newName = $this->_temp['name'];
			if ( $oldName )
			{
				unset($confMgr->_serv['ext'][$oldName]);
				unset($confMgr->_servErr['ext'][$oldName]);
			}
			$confMgr->_serv['ext'][$newName] = $this->_temp;
			$confMgr->_servErr['ext'][$newName] = $this->_tempErr;
			$confMgr->refreshExtApp(NULL, $confMgr->_serv);

		}
		elseif( $this->_objName === 'scr' )
		{
			$oldSuffix = $this->_objId;
			$newSuffix = $this->_temp['suffix'];
			if ( $oldSuffix )
			{
				unset($confMgr->_serv['scriptHandler'][$oldSuffix]);
				unset($confMgr->_servErr['scriptHandler'][$oldSuffix]);
			}
			$this->_temp['action'] = '<a href="javascript:wiz(\'ESscr\',\''.$newSuffix.'\',\'servScript1.php\')">Edit</a>&nbsp;&nbsp;&nbsp;<a href="javascript:del(\'DSscr\',\''.$newSuffix.'\')">Delete</a>';
			$confMgr->_serv['scriptHandler'][$newSuffix] = $this->_temp;
			$confMgr->_servErr['scriptHandler'][$newSuffix] = $this->_tempErr;
		}
		elseif( $this->_objName === 'vh' )
		{
			$oldName = $this->_objId;
			$newName = $this->_temp['name'];
			if ( $oldName != $newName )
			{
				if ( $this->_actType == 'E' )
				{
					unset($confMgr->_serv['vhTop'][$oldName]);
					unset($confMgr->_servErr['vhTop'][$oldName]);
					unset($confMgr->_modTime['vh'][$oldName]);
					unset($confMgr->_vhosts[$oldName]);
					unset($confMgr->_vhostsErr[$oldName]);
				}
				$updateMenu = true;
			}
			$confMgr->_serv['vhTop'][$newName] = $this->_temp;
			$confMgr->_servErr['vhTop'][$newName] = $this->_tempErr;
			$confMgr->refreshVhRoot($newName);
		}
		return $updateMenu;
	}


	function saveListenerValue(&$confMgr)
	{
		$updateMenu = false;
		if ( $this->_actType != 'E' )
			$updateMenu = true;
		$oldName = $this->_objId;
		$newName = $this->_temp['name'];
		$oldSecure = $confMgr->_serv['listeners'][$oldName]['secure'];
		$newSecure = $this->_temp['secure'];
		if ( $oldSecure != $newSecure )
			$updateMenu = true;
		if ( $oldName != $newName )
		{
			$updateMenu = true;
			unset($confMgr->_serv['listeners'][$oldName]);
			unset($confMgr->_servErr['listeners'][$oldName]);
			$this->_temp['action'] = '<a href="javascript:wiz(\'ELgeneral\', \''.$newName.'\',\'listenerGeneral1.php\')">Edit</a>&nbsp;&nbsp;&nbsp;<a href="javascript:del(\'DL\', \''.$newName.'\')">Delete</a>';
		}
		$confMgr->_serv['listeners'][$newName] = $this->_temp;
		$confMgr->_servErr['listeners'][$newName] = $this->_tempErr;
		return $updateMenu;
	}

	function saveVhostValue(&$confMgr)
	{
		$vhname = $this->_objId;
		if ( $this->_objName === 'general' )
		{
			$confMgr->_vhosts[$vhname]['general'] = $this->_temp;
			$confMgr->_vhostsErr[$vhname]['general'] = $this->_tempErr;
			$confMgr->refreshVhDocRoot($vhname);
		}
		elseif ( $this->_objName === 'secg' )
		{
			$confMgr->_vhosts[$vhname]['security']['general'] = $this->_temp;
			$confMgr->_vhostsErr[$vhname]['security']['general'] = $this->_tempErr;
		}
		elseif ( $this->_objName === 'sechl' )
		{
			$confMgr->_vhosts[$vhname]['security']['hotlink'] = $this->_temp;
			$confMgr->_vhostsErr[$vhname]['security']['hotlink'] = $this->_tempErr;
		}
		elseif ( $this->_objName === 'secac' )
		{
			$confMgr->_vhosts[$vhname]['security']['accessControl'] = $this->_temp;
			$confMgr->_vhostsErr[$vhname]['security']['accessControl'] = $this->_tempErr;
		}
		elseif ( substr($this->_objName, 0, 3) === 'ctx' )
		{
			$oldUri = $this->_subId;
			$newUri = $this->_temp['uri'];
			$type = $this->_objName{3};
			$t= $this->getContextTypeByCode($type);
			$ctx = &$confMgr->_vhosts[$vhname]['context'][$t];
			$err = &$confMgr->_vhostsErr[$vhname]['context'][$t];
			if ( $oldUri != $newUri )
			{
				unset( $ctx[$oldUri] );
				unset( $err[$oldUri] );
			}
			$ctx[$newUri] = $this->_temp;
			$err[$newUri] = $this->_tempErr; 
		}
		elseif ( $this->_objName === 'ext' )
		{
			$oldName = $this->_subId;
			$newName = $this->_temp['name'];
			if ( $oldName )
			{
				unset($confMgr->_vhosts[$vhname]['ext'][$oldName]);
				unset($confMgr->_vhostsErr[$vhname]['ext'][$oldName]);
			}
			$confMgr->_vhosts[$vhname]['ext'][$newName] = $this->_temp;
			$confMgr->_vhostsErr[$vhname]['ext'][$newName] = $this->_tempErr;
			$confMgr->refreshExtApp( $vhname, $confMgr->_vhosts[$vhname] );
		}
		elseif( $this->_objName === 'scr' )
		{
			$oldSuffix = $this->_subId;
			$newSuffix = $this->_temp['suffix'];
			if ( $oldSuffix != $newSuffix )
			{
				unset($confMgr->_vhosts[$vhname]['scriptHandler'][$oldSuffix]);
				unset($confMgr->_vhostsErr[$vhname]['scriptHandler'][$oldSuffix]);
			}
			$this->_temp['action'] = '<a href="javascript:wiz(\'EVscr'.$newSuffix."','".$vhname.'\',\'vhScript1.php\')">Edit</a>&nbsp;&nbsp;&nbsp;<a href="javascript:del(\'DVscr'.$newSuffix."','".$vhname.'\')">Delete</a>';	
			$confMgr->_vhosts[$vhname]['scriptHandler'][$newSuffix] = $this->_temp;
			$confMgr->_vhostsErr[$vhname]['scriptHandler'][$newSuffix] = $this->_tempErr;
		}
		elseif( $this->_objName === 'hta' )
		{
			$oldName = $this->_subId;
			$newName = $this->_temp['name'];
			if ( $oldName != $newName )
			{
				unset( $confMgr->_vhosts[$vhname]['security']['realm'][$oldName]);
				unset( $confMgr->_vhostsErr[$vhname]['security']['realm'][$oldName] );
			}
			$this->_temp['action'] = '<a href="javascript:wiz(\'EVhta'.$newName."','".$vhname.'\',\'vhSecurity1.php\')">Edit</a>&nbsp;&nbsp;&nbsp;<a href="javascript:del(\'DVhta'.$newName."','".$vhname.'\')">Delete</a>';
			$confMgr->_vhosts[$vhname]['security']['realm'][$newName] = $this->_temp;
			$confMgr->_vhostsErr[$vhname]['security']['realm'][$newName] = $this->_tempErr;
			$confMgr->refreshVhRealms( $vhname, $confMgr->_vhosts[$vhname] );
		}
		elseif ( $this->_objName === 'err' )
		{
			$oldCode = $this->_subId;
			$newCode = $this->_temp['errCode'];
			if ( $oldCode )
			{
				unset( $confMgr->_vhosts[$vhname]['errUrl'][$oldCode] );
				unset( $confMgr->_vhostsErr[$vhname]['errUrl'][$oldCode] );
			}
			$this->_temp['action'] = '<a href="javascript:wiz(\'EVerr'.$newCode."','".$vhname.'\',\'vhError1.php\')">Edit</a>&nbsp;&nbsp;&nbsp;<a href="javascript:del(\'DVerr'.$newCode."','".$vhname.'\')">Delete</a>';

			$confMgr->_vhosts[$vhname]['errUrl'][$newCode] = $this->_temp;
			$confMgr->_vhostsErr[$vhname]['errUrl'][$newCode] = $this->_tempErr;
		}
		return false;
	}

	function getContextTypeByCode($code)
	{
		$types = array('g'=>'NULL', 'j'=>'webapp', 's'=>'servlet',
					   'f'=>'fcgi', 'p'=>'proxy', 'c'=>'cgi', 'r'=>'redirect');
		return $types[$code];
	}

	function extractValue($fromPage)
	{
		$go = 0;
		/* 0: stay current page, -1: stay current page, has err; 1: next page*/ 

		if ( $this->_tag === 'S' )
			$go = $this->extractServValue($fromPage);
		elseif ( $this->_tag === 'L' )
			$go = $this->extractListenerValue($fromPage);
		elseif ( $this->_tag === 'V' )
			$go = $this->extractVhostValue($fromPage);
		return $go;
	}

	function extractServValue($fromPage)
	{
		if ( $this->_objName === 'mime' )
		{
			return $this->extractMime();
		}

		if ( $this->_objName === 'general' )
		{
			$tids = array( 'servGeneral1.php' => 'SERV_PROCESS',
						   'servGeneral2.php' => 'SERV_GENERAL',
						   'servGeneral3.php' => 'SERV_LOG',
						   'servGeneral4.php' => 'SERV_ACLOG',
						   'servGeneral5.php' => 'A_HTACCESS',
						   'servGeneral6.php' => 'SERV_EXPIRES' );
		}
		elseif ( $this->_objName === 'tuning' )
		{
			$tids = array('servTuning1.php' => 'SERV_TUNING_CONN',
						  'servTuning2.php' => 'SERV_TUNING_REQ',
						  'servTuning3.php' => 'SERV_TUNING_GZIP');
		}
		elseif ( $this->_objName === 'security' )
		{
			$tids = array( 'servSecurity1.php' => 'SERV_SEC_FILE', 
						   'servSecurity2.php' => 'SERV_SEC_CGI',
						   'servSecurity5.php' => 'SERV_SEC_CONN',
						   'servSecurity4.php' => 'SERV_SEC_DENY',
						   'servSecurity3.php' => 'A_SECAC' );
		}
		elseif ( $this->_objName === 'ext' )
		{
			$tid = 'A_EXT';
			$tblDef = &$GLOBALS['_DTblDef_'];
			$table = &$tblDef->getTblDef($tids);
			$table->_dattrs[6]->_minVal = 2;
		}
		elseif ( $this->_objName === 'scr' )
		{
			$tid = 'A_SCRIPT' ;
		}
		elseif ( $this->_objName === 'vh' )
		{
			$tid = 'VH_TOP';
		}
		elseif ( $this->_objName === 'admin' )
		{
			$tids = array( 'adminServGeneral1.php' => 'ADMIN_PHP',
						   'vhGeneral2.php' => 'VH_LOG',
						   'vhGeneral3.php' => 'VH_ACLOG',
						   'adminServGeneral2.php' => 'A_SECAC' );
		}

		if ( ! isset($tid) )
			$tid = $tids[$fromPage];
		$validate = new ValidateData();
		$goFlag = $validate->extract( $tid, $_POST, $this->_temp, $this->_tempErr);
		$isValid = $validate->validate( $tid, $this->_temp, $this->_tempErr, $this->_attr );
		if ( $isValid )
			return $goFlag;
		else
			return -1;
	}

	function extractMime()
	{
		$act = $_POST['mAct'];
		if ( $act == 'D' )
		{
			$chk = &$this->findPostArray('chk');
			foreach ( $chk as $key )
			{
				unset($this->_temp[$key]);
			}
		}
		else
		{
			$suffix = &$this->findPostArray('suffix');
			$type = &$this->findPostArray('type');
			$this->_temp = array();
			foreach( $suffix as $index => $suf )
			{
				$a1 = preg_split("/[\s,;]+/", $suf, -1, PREG_SPLIT_NO_EMPTY);
				$a = implode(',', $a1);

				$b = $type[$index];
				if ( $b )
					$b = trim($b);
				if ( $a && $b )
				{
					$c = preg_match("/^[A-z0-9_\-,]+$/", $a); 
					$d = preg_match("/^[A-z0-9_\-\.]+\/[A-z0-9_\-\.]+(\s*;?.*)$/", $b);
					if ( $c == 1 && $d == 1 )
						$this->_temp[$a] = $b;
					else
					{
						$this->_tempErr = $a;
						return -1;
					}
				}
			}
		}
		ksort($this->_temp);
		reset($this->_temp);
		return 1;
	}

	function extractUserDB($fromPage)
	{
		$act = $_POST['mAct'];
		$this->_tempErr = '';
		$action = $act{0};
		if ( $action == 'D' )
		{
			$name = substr($act, 1);
			unset($this->_temp[$name]);
			return 0;
		}

		if ( $fromPage == 'userDB2.php' )
		{
			if ( $action == 'C' )
				return 1;
			$username = trim($_POST['username']);
			$groups = trim($_POST['groups']);
			$pass = $_POST['pass'];
			$pass1 = $_POST['pass1'];
			if ( $username == '' )
				$this->_tempErr['username'] = 'Invalid user name! ';

			if ( $groups != '' )
			{
				$vals = preg_split("/[,;]+/", $groups, -1, PREG_SPLIT_NO_EMPTY);
				sort($vals);
				$groups = implode(', ', $vals);
			}

			if ( $pass != $pass1 )
				$this->_tempErr['pass1'] = 'Wrong password - does not match! ';

			if ( $action == 'A' )
			{ 
				if ( $pass == '' )
					$this->_tempErr['pass'] = 'Missing password!';

				if ( isset($this->_temp[$username]) )
					$this->_tempErr['username'] = 'Cannot change to an existing user name '.$username;
			}
			
			if ( $action == 'E' )
			{
				$oldname = substr($act, 1);
				$user = $this->_temp[$oldname];
				if ( $username != $oldname )
				{
					if ( isset($this->_temp[$username]) )
					{
						$this->_tempErr['username'] = 'Cannot change to an existing user name '.$username;
						return -1;
					}
					unset($this->_temp[$oldname]);
				}
			}
			if ( $this->_tempErr != '' )
				return -1;

			$user['group'] = $groups;
			if ( strlen($pass) > 0 )
			{
				$valid_chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789/.";
				$salt = $valid_chars[rand(0,strlen($valid_chars)-1)];
				$salt .= $valid_chars[rand(0,strlen($valid_chars)-1)];
				$user['passwd'] = crypt($pass, $salt);
			}
			$this->_temp[$username] = $user;
			ksort($this->_temp);
			reset($this->_temp);
		}
		return 1;
	}

	function extractGroupDB($fromPage)
	{
		$act = $_POST['mAct'];
		$this->_tempErr = '';
		$action = $act{0};
		if ( $action == 'D' )
		{
			$name = substr($act, 1);
			unset($this->_temp[$name]);
			return 0;
		}

		if ( $fromPage == 'groupDB2.php' )
		{
			if ( $action == 'C' )
				return 1;
			$groupname = trim($_POST['groupname']);
			$users = trim($_POST['users']);
			if ( $groupname == '' )
				$this->_tempErr['groupname'] = 'Invalid group name! ';
			if ( $users != '' )
			{
				$vals = preg_split("/[\s,;]+/", $users, -1, PREG_SPLIT_NO_EMPTY);
				sort($vals);
				$users = implode(' ', $vals);
			}

			if ( $action == 'A' )
			{ 
				if ( isset($this->_temp[$groupname]) )
					$this->_tempErr['groupname'] = 'Cannot change to an existing group name ' . $groupname;
			}
			
			if ( $action == 'E' )
			{
				$oldname = substr($act, 1);
				if ( $groupname != $oldname )
				{
					if ( isset($this->_temp[$groupname]) )
					{
						$this->_tempErr['groupname'] = 'Cannot change to an existing group name ' . $groupname;
						return -1;
					}
					unset($this->_temp[$oldname]);
				}
			}
			if ( $this->_tempErr != '' )
				return -1;

			$this->_temp[$groupname] = $users;
			ksort($this->_temp);
			reset($this->_temp);
		}
		return 1;
	}


	function extractListenerValue( $fromPage )
	{
		if ( $fromPage == 'listenerSSL2.php' )
			return $this->extractListenerSSL();
		if ( $this->_objName == 'vh' )
			return $this->extractVhMap();

		if ( $this->_objName == 'general' )
			$tid = 'L_GENERAL';
		elseif ( $this->_objName == 'ssl' )
			$tid = 'L_CERT';
		$validate = new ValidateData();
		return $validate->extract( $tid, $_POST, $this->_temp, $this->_tempErr);
	}

	function extractVhMap()
	{
		$validate = new ValidateData();
		$tid = 'L_VHMAP';
		$vh = &$this->findPostArray('vh');
		$goFlag = 1;
		unset($this->_temp['vhmap']);
		unset($this->_tempErr['vhmap']);
		foreach( $vh as $key => $value )
		{
			$t = array();
			$t['vh'] = $value;
			$t['domain'] = $_POST["domain$key"];

			$go = $validate->extract( $tid, $t, $this->_temp['vhmap'][$value], 
									  $this->_tempErr['vhmap'][$value] );
			if ( $go <= 0 )
				$goFlag = $go;

		}
		return $goFlag;
	}

	function extractListenerSSL()
	{

		$c = array( 'SSLv2' => ' ', 'SSLv3' => ' ', 'TLSv1' => ' ',
					'HIGH' => ' ', 'MEDIUM' => ' ', 'LOW' => ' ', 'EXPORT56' => ' ', 'EXPORT40' => ' ');
		$ciphers = 'ALL:!ADH';
		if ( isset( $_POST['ck0'] ) )
			$ciphers .= ':+SSLv2';
		else
			$ciphers .= '!SSLv2';

		if ( isset( $_POST['ck1'] ))
			$ciphers .= ':+SSLv3';
		else
			$ciphers .= ':!SSLv3';

		if ( isset( $_POST['ck2'] ))
			$ciphers .= ':+TLSv1';
		else
			$ciphers .= ':!TLSv1';

		if ( isset( $_POST['ck3']))
			$ciphers .= ':+HIGH';
		else
			$ciphers .= ':!HIGH';

		if ( isset( $_POST['ck4']))
			$ciphers .= ':+MEDIUM';
		else
			$ciphers .= ':!MEDIUM';

		if ( isset( $_POST['ck5']))
			$ciphers .= ':+LOW';
		else
			$ciphers .= ':!LOW';

		if ( isset( $_POST['ck6']))
			$ciphers .= ':+EXPORT56';
		else
			$ciphers .= ':!EXPORT56';

		if ( isset( $_POST['ck7']))
			$ciphers .= ':+EXPORT40';
		else
			$ciphers .= ':!EXPORT40';

		$ciphers .= ':@STRENGTH';
		$this->_temp['ciphers'] = $ciphers;
		return 1;
	}

	function extractVhostValue($fromPage)
	{
		if ( $this->_objName == 'udb' )
		{
			return $this->extractUserDB($fromPage);
		}
		elseif ( $this->_objName == 'gdb' )
		{
			return $this->extractGroupDB($fromPage);
		}


		$validate = new ValidateData();
		$tblDef = &$GLOBALS['_DTblDef_'];

		if ( $this->_objName === 'general' )
		{
			$tids = array( 'vhGeneral1.php' => 'VH_GENERAL',
						   'vhGeneral2.php' => 'VH_LOG',
						   'vhGeneral3.php' => 'VH_ACLOG',
						   'vhGeneral4.php' => 'VH_INDXF',
						   'vhGeneral5.php' => 'A_HTACCESS',
						   'vhGeneral6.php' => 'VH_EXPIRES' );
		}
		elseif ( $this->_objName === 'secg' )
		{
			$tid = 'VH_SECG';
		}
		elseif ( $this->_objName === 'sechl' )
		{
			$tid = 'VH_SECHL';
		}
		elseif ( $this->_objName === 'secac' )
		{
			$tid = 'A_SECAC';
		}
		elseif ( $this->_objName === 'err' )
		{
			$tid = 'VH_ERRPG';
		}
		elseif ( $this->_objName === 'scr' )
		{
			$tid = 'A_SCRIPT' ;
		}
		elseif ( $this->_objName === 'hta' )
		{
			$tid = 'VH_REALM';
		} 
		elseif ( $this->_objName === 'ext' )
		{
			$tid = 'A_EXT';
			$table = &$tblDef->getTblDef($tid);
			$table->_dattrs[6]->_minVal = 3;
		}
		elseif ( substr($this->_objName, 0, 3) === 'ctx' )
		{
			$tid = 'VH_CTX' . ucfirst($this->_objName{3});
		}

		if ( !isset( $tid ) )
			$tid = $tids[$fromPage];
		$goFlag = $validate->extract( $tid, $_POST, $this->_temp, $this->_tempErr);
		$isValid = $validate->validate($tid, $this->_temp, $this->_tempErr, $this->_attr);
		if ( $isValid )
			return $goFlag;
		else
			return -1;
	}

	function &findPostArray($tag)
	{
		$res = array();
		$len = strlen($tag);
		foreach ($_POST as $key => $value)
		{
			if ( strstr($key, $tag) )
			{
				$index = substr($key, $len);
				$res[$index] = $value;
			}
		}
		return $res;
	}

	function dbg_out($tag, &$obj)
	{
		echo "<!-- $tag --\n";
		var_dump($obj);
		echo "-->\n";
	}
	function dbg_tag($tag)
	{
		echo "<!-- $tag -->\n";
	}

}

?>
