<?php
$title = 'Virtual Host Context settings';
$curPage = 'vhContext1.php';

$vhname = $wizard->_objId;
$context = &$wizard->_temp;
$err = &$wizard->_tempErr;
$_SESSION['VH_ROOT'] = $wizard->_attr['VH_ROOT'];
$_SESSION['DOC_ROOT'] = $wizard->_attr['DOC_ROOT'];

$tips = array();
$tipExpire = 'Expires settings will override virtual host and server level settings. Expires Default syntax is A|Mseconds, means after base time (A or M) plus the specified time in seconds, the file will expire. "A" means client access time, "M" means file modified time.';

if ( $wizard->_objName === 'ctxg' )
{
	$ctxName = 'General';
	$cur_table = &$tblDef->getTblDef('VH_CTXG');

	$tips[] = 'A general context can be used to map a URI to a directory either outside document root or within it. The directory can be absolute path or relative to document root(default), $VH_ROOT or $SERVER_ROOT.';
	$tips[] = 'Check "Accessible" will allow browsing static files in this context. You may want to disable it to prevent viewing static files, for e.g. when you update the content.';
	$tips[] = $tipExpire;
}
elseif ( $wizard->_objName === 'ctxj' )
{
	$ctxName = 'Java Web App';
	$cur_table = &$tblDef->getTblDef('VH_CTXJ');
	$cur_table->_dattrs['handler']->_maxVal = &$wizard->_attr['handlers'];

	$tips[] = 'Java web app context is used to automatically import a predefined Java Application in an AJPv13 compilant Java servlet engine, the servlet engine should be set up in external app section (both server and virtual host level).';
	$tips[] = 'Location is the directory that contains web application files, which includes WEB-INF/ sub directory.';
	$tips[] = 'The web server will automatically import configuration file of web application, which usually is WEB-INF/web.xml under the driectory specified by "location".';
	$tips[] = 'If the servlet engine runs on a different machine, it is recommended to make a copy of webapps directory locally. Otherwise you must put the files in a common accessible network drive, which may affect performance. ';
	$tips[] = $tipExpire;
}
elseif ( $wizard->_objName === 'ctxs' )
{
	$ctxName = 'Servlet';
	$cur_table = &$tblDef->getTblDef('VH_CTXS');
	$cur_table->_dattrs['handler']->_maxVal = &$wizard->_attr['handlers'];
	$tips[] = 'A "Servlet" context is used to import a specific servlet under a web application, whereas a "Java Web App" context will import every thing automatically. You do not need to set up individual Servlet Context for each servlet defined in a web application.';
}
elseif ( $wizard->_objName === 'ctxf' )
{
	$ctxName = 'Fast CGI';
	$cur_table = &$tblDef->getTblDef('VH_CTXF');
	$cur_table->_dattrs['handler']->_maxVal = &$wizard->_attr['handlers'];
	$tips[] = 'A FCGI context is a mount point of Fast CGI application. The Fast CGI Application must be pre-defined at server level or virtual host level.';
}
elseif ( $wizard->_objName === 'ctxp' )
{
	$ctxName = 'Proxy';
	$cur_table = &$tblDef->getTblDef('VH_CTXP');
	$cur_table->_dattrs['handler']->_maxVal = &$wizard->_attr['handlers'];
	$tips[] = 'A proxy context enables this virtual host serving as a transparant reverse proxy server to an external web server or application server.';
	$tips[] = 'External web server must be pre-defined under External Apps at server/virtual host level.';
}
elseif ( $wizard->_objName === 'ctxc' )
{
	$ctxName = 'CGI';
	$cur_table = &$tblDef->getTblDef('VH_CTXC');
	$tips[] = 'A CGI context can be used to specify a directory only contains CGI scripts. Path can be absolute path or relative to $SERVER_ROOT, $VH_ROOT or $DOC_ROOT(default). Path and URI must be ended with "/" for a cgi-bin directory.';
	$tips[] = 'If only a specific script is needed in that directory, it is recommended to create a CGI context for that script only. In this case, path and URI need not be a directory. For e.g., path can be ~/myapp/myscript.pl, URI can be /myapp/myscript.pl. All other files will not be served as CGI.';
}
elseif ( $wizard->_objName === 'ctxr' )
{
	$ctxName = 'Redirect';
	$cur_table = &$tblDef->getTblDef('VH_CTXR');
	$tips[] = 'Set up redirect URI here. If it is external redirect, you can specify the status code. Internal redirect has to start with "/", external redirect can either start with "/" or with "http(s)://".';
}

if ( $wizard->_objName != 'ctxp' )
{
	$cur_table->_dattrs['realm']->_maxVal = &$wizard->_attr['realms'];

	$tips[] = 'Allow Override will be effective only if server/vhost level setting is enabled. Context will inherit virtual host settings by default when nothing is checked. When nothing but "None" is checked, access control file will be ignored. When "Access Control" is checked, directives "Order", "Allow" and "Deny" are allowed. When "Authentication" is checked, directives "AuthGroupFile", "AuthName", "AuthType", "AuthUserFile", "Require" are allowed.';
	$tips[] = 'A Context can be protected with predefined realm, which is set up in the virtual host security section. Optionally, an alternative name and additional requirements can be specified.';

	$tips[] = 'Additional access control can be specified for a context. It is only effective when "Context Access Contorl" is enabled in virtual host security section.';
}
if ( $wizard->_objName === 'ctxr' )
{
	$onload = 'onload="javascript:initScreen(' . $context['externalRedirect'] . ')"';
?>

<script language="javascript">
<!-- begin

function initScreen(type)
{
	if ( type == 1 )
		checkStatus();
	else
		chkExternal(type);

}

function chkExternal(type)
{
	if ( type == 1 )
	{
		document.wizardform.statusCode.disabled = false;
	}
	else
	{
		document.wizardform.statusCode.selectedIndex = 0;
		document.wizardform.statusCode.disabled = true;
	}
}

function checkStatus()
{
	i = document.wizardform.statusCode.selectedIndex;
	if ( i <= 6 )
	{
		document.wizardform.location.disabled = false;
	}
	else
	{
		document.wizardform.location.value = "";
		document.wizardform.location.disabled = true;
	}
}

// end -->
</script>


<?php 
}
include 'wizardHeader.php';
?>



<table width="100%" border="0" cellpadding="0" cellspacing="10">
	<?php $tblDef->showTitleLabel("Virtual Host $vhname - $ctxName Contexts"); ?>
	<tr><td>
<?php 
$cur_table->setTitle('L', (isset($context['uri'])?$context['uri']:'New Context'));
$cur_table->toHtmlInput($context, $err, NULL); 
?>
	</td></tr>
</table>

<?php 
include 'wizardFooter.php';
?>


