
CURDIR=`dirname "$0"`
cd $CURDIR
CURDIR=`pwd`
LSWSHOME=`dirname $CURDIR`
LSWSHOME=`dirname $LSWSHOME`


PF=`uname -p`
OS=`uname -s`


if [ "x$OS" = "xFreeBSD" ]; then
	if [ "x$PF" = "xi386" ]; then
		DN="i386-freebsd"
	else
		echo "unkown platform '$PL' for FreeBSD."
		exit 1
	fi
elif [ "x$OS" = "xSunOS" ]; then
	if [ "x$PF" = "xsparc" ]; then
		DN="sparc-solaris"
	elif [ "x$PF" = "xi386" ]; then
		DN="i386-solaris"
	else
		echo "unkown platform '$PL' for Sun Solaris."
		exit 1
	fi
elif [ "x$OS" = "xLinux" ]; then
	PF=`uname -m`
	if [ "x$PF" = "xi686" ] || [ "x$PF" = "xi586" ] || [ "x$PF" = "xi486" ] || [ "x$PF" = "xi386" ]; then
		DN="i386-linux"
	elif [ "x$PF" = "xppc" ]; then
		DN="ppc-linux"
	else
		echo "unkown platform '$PL' for Linux."
		exit 1
	fi
fi



SEL=2
SUCC=0

while [ $SUCC -eq "0" ]; do

	cat <<EOF

Please select from the following third party opcode cache for PHP

0. No Cache
1. Alternative PHP Cache (APC)
2. Turck MMCache 

NOTE: APC may not work properly on SMP Server (with multiple CPUs), please use 
	  Turck MMCache instead.

EOF

	printf "%s" "Please select (0-2) [2]? "
	read TMPS
	echo ""
	if [ "x$TMPS" != "x" ]; then
		if [ `expr "$TMPS" : '[012]'` -gt 0 ]; then
			SEL=$TMPS
			SUCC=1
		fi
	else
		SUCC=1
	fi
done

if [ ! -w $LSWSHOME/conf/php.ini ]; then
	echo "Access is denied to $LSWSHOME/conf/php.ini"
	exit 1
fi

cp $LSWSHOME/conf/php.ini $LSWSHOME/conf/php.ini.bak
cp $LSWSHOME/conf/php.ini $LSWSHOME/conf/php.ini.old

sed -e "s/^.*zend_extension.*apc\.so.*$//" -e "s/^.*zend_extension.*mmcache\.so.*$//" -e "s/^.*mmcache\..*=.*$//" "$LSWSHOME/conf/php.ini.old" > "$LSWSHOME/conf/php.ini"

if [ $SEL -eq 1 ]; then

	if [ ! -f $LSWSHOME/lib/apc.so ]; then
		echo "[ERROR] Can not find $LSWSHOME/lib/apc.so, please run install.sh again!"
		exit 1
	fi

	cat <<EOF >>$LSWSHOME/conf/php.ini

#APC configuration
zend_extension="../lib/apc.so"

EOF

elif [ $SEL -eq 2 ]; then

	if [ ! -f $LSWSHOME/lib/mmcache.so ]; then
		cd $LSWSHOME/lib
		wget "http://www.litespeedtech.com/packages/mmcache/mmcache-$DN.tar.gz"
		if [ $? -eq 0 ]; then
			gunzip -c "mmcache-$DN.tar.gz" | tar xvf -
			rm mmcache-$DN.tar.gz
		else
			cat <<EOF 
[WARN] Can not retrieve binary package for MMCache from www.litespeedtech.com, 
       please download it manually from 
           http://www.litespeedtech.com/download.html 
       or build binary from source code.
       Please copy mmcache.so to $LSWSHOME/lib/mmcache.so.

EOF
		fi
	
	fi
	
	cat <<EOF >>$LSWSHOME/conf/php.ini

#Turck MMCache configuration
zend_extension="../lib/mmcache.so"
mmcache.shm_size="16"
mmcache.cache_dir="/tmp/mmcache"
mmcache.enable="1"
mmcache.optimizer="0"
mmcache.check_mtime="1"
mmcache.debug="0"
mmcache.filter=""
mmcache.shm_max="0"
mmcache.shm_ttl="0"
mmcache.shm_prune_period="0"
mmcache.shm_only="0"
mmcache.compress="1"

EOF

if [ ! -d /tmp/mmcache ]; then
    mkdir /tmp/mmcache
fi
chmod 0777 /tmp/mmcache

fi


rm $LSWSHOME/conf/php.ini.old

